/********************************************************************
  error.c
    VIOSɸѴؿ error ؿ
*********************************************************************/
#include <syslog.h>
#include <stdarg.h>	    /* ѰؿΤ */
#include "vios_lib.h"

#define	MAXLINE	 4096
static int daemon_proc = 0; /* ץϥǡ󤫡(default no) */


static void  err_doit(int, int, const char *, va_list);


/* ̿ŪǤ̵顼Ѵؿ(system call)*
 * åϤreturn롣           */
void
errs_ret(const char *fmt, ...)
{
    va_list		ap;

    va_start(ap, fmt);
    err_doit(1, LOG_INFO, fmt, ap);
    va_end(ap);
    return;
}


/* ̿Ūʥ顼Ѵؿ(system call)*
 * åϤλ롣       */
void
errs_exit(const char *fmt, ...)
{
    va_list		ap;
    
    va_start(ap, fmt);
    err_doit(1, LOG_ERR, fmt, ap);
    va_end(ap);
    exit(1);
}


/* ̿Ūʥ顼Ѵؿ(system call)       *
 * åϤcoreǤλ롣*/
void
errs_dump(const char *fmt, ...)
{
    va_list		ap;
    
    va_start(ap, fmt);
    err_doit(1, LOG_ERR, fmt, ap);
    va_end(ap);
    abort();  /* core dump  */
    exit(1);
}


/* ̿ŪǤ̵顼Ѵؿ(no system call)*
 * åϤreturn롣              */
void
err_ret(const char *fmt, ...)
{
    va_list		ap;

    va_start(ap, fmt);
    err_doit(0, LOG_INFO, fmt, ap);
    va_end(ap);
    return;
}


/* ̿Ūʥ顼Ѵؿ(no system call)*
 * åϤλ롣          */
void
err_exit(const char *fmt, ...)
{
    va_list		ap;

    va_start(ap, fmt);
    err_doit(0, LOG_ERR, fmt, ap);
    va_end(ap);
    exit(1);
}


/* 顼ؿ
 * Caller specifies "errnoflag" and "level". */
static void
err_doit(int errnoflag, int level, const char *fmt, va_list ap)
{
    int		errno_save, n;
    char	buf[MAXLINE];

    errno_save = errno;	/* ɽΤ¸ */
#ifdef	HAVE_VSNPRINTF
    vsnprintf(buf, sizeof(buf), fmt, ap); /* safe   */
#else
    vsprintf(buf, fmt, ap);	          /* no safe */
#endif

    n = strlen(buf);
    if (errnoflag)
	snprintf(buf+n, sizeof(buf)-n, ": %s", strerror(errno_save));
    strcat(buf, "\n");

    if (daemon_proc) {
	syslog(level, buf);
    } else {
	fflush(stdout);	 /* ɸ(顼)Ϥξ */
	fputs(buf, stderr);
	fflush(stderr);
    }
    return;
}
