/********************************************************************
  image_io.c
  Solaris CCˤԶΤˡextern "C" ѤƤޤȤ
  󥯥롼ɤǤʤΤǤΤ褦ʷˡʥ顼ѥåѡǤ̵

  VIOS image Ϣؿ
*********************************************************************/
#include <pgm.h>
#include "vios_lib.h"

void
Pgm_init(int* argc, char** argv)
{
    pgm_init(argc, argv);
}

int
Pgm_load(char* name, int* rows, int* cols, int** data)
{
    FILE* infile;
    int	  format;
    gray  maxval;
    gray* rowdata;

    int	  x, y;
    int	  index = 0;

    infile = pm_openr(name);
    pgm_readpgminit(infile, rows, cols, &maxval, &format);

    if(PGM_FORMAT_TYPE(format) == -1) {
	pm_close(infile);
	err_ret("%s is Not PGM file.\n", name);
	return -1;
    }

    /* ǡγǼ */
    *data    = (int*)Malloc(*rows * *cols * sizeof(int));
    rowdata = pgm_allocrow(*rows);

    /* ǡɤ߹ */
    for(y=0; y < *cols; y++) {
	pgm_readpgmrow(infile, rowdata, *rows, maxval, format);
	for(x=0; x < *rows; x++) {
	    (*data)[index++] = (int)rowdata[x];
	}
    }
    pgm_freerow(rowdata);
    pm_close(infile);

    return 0;
}

int
Pgm_save(char* name, int rows, int cols, int* data)
{
    FILE* outfile;
    gray* rowdata;

    int   x, y;
    int	  maxval = 0;

    /* ͤθ */
    for(y=0; y<cols; y++)
	for(x=0; x<rows; x++)
	    if(data[y * rows + x] > maxval) maxval = data[y * rows + x];

    outfile = pm_openw(name);
/*    pgm_writepgminit(outfile, rows, cols, maxval, 1); */

    rowdata = pgm_allocrow(rows);

    fprintf(outfile, "P2\n#This file generate by vios.\n%d %d\n%d\n",\
	    rows, cols, maxval);
    for(y=0; y<cols; y++) {
	for(x=0; x<rows; x++)
	    rowdata[x] = (gray)data[y * rows + x];	/* 줬 */
	pgm_writepgmrow(outfile, rowdata, rows, maxval, 1);
    }

    pgm_freerow(rowdata);
    pm_close(outfile);

    return 0;
}
