/********************************************************************
  vios_lib.h
    VIOSɸѴؿ饤֥إåե
*********************************************************************/

#ifndef __VS_LIBSTD_H
#define __VS_LIBSTD_H

#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <unistd.h>
#include <strings.h>
#include <sys/socket.h>
#include <signal.h>
#include <errno.h>
#include <ctype.h>
#include <sys/uio.h>
#include <sys/time.h>
#include <netinet/in.h>
#ifdef __linux__
typedef uint16_t in_port_t;   /*Linux Ǥ in_port_t ̤*/
#endif

#ifdef USE_DOUBLE
#define USE_FLOAT_DOUBLE 1
#endif

/*FLOAT  double Ȥư*/
#ifdef USE_FLOAT_DOUBLE 
#define FLOAT double
#endif
/*FLOAT  long double Ȥư*/
#ifdef USE_FLOAT_LONGDOUBLE
#define FLOAT long double
#define DOUBLE long double
#endif
/*DOUBLE  long double Ȥư*/
#ifdef USE_DOUBLE_LONGDOUBLE
#define DOUBLE long double
#endif
/*ǥե*/
#ifndef FLOAT 
#define FLOAT float
#endif
#ifndef DOUBLE
#define DOUBLE double
#endif



#define	LISTENQ	 256	  /* åԤ塼Ĺ    */
                          /* (tcpfunc.c, wrapsock.c)     */
#ifdef  __cplusplus
extern "C" {
#endif

/************  error.c  ************/

/* Ūerrnoʤɤ򰷤Բ */

extern void	errs_ret(const char *fmt, ...);
extern void	errs_exit(const char *fmt, ...);
extern void	errs_dump(const char *fmt, ...);
extern void	err_ret(const char *fmt, ...);
extern void	err_exit(const char *fmt, ...);


/***********  tcpfunc.c  ***********/

extern int	Tcp_connect(const char *, const char *);
extern int	Tcp_listen(const char *, const char *, socklen_t *);


/***********  image_io.c  ***********/

extern void	Pgm_init(int* argc, char** argv);
extern int	Pgm_load(char* name, int* rows, int* cols, int** data);
extern int	Pgm_save(char* name, int rows, int cols, int* data);


/***********   wrapnet.c  ***********/

extern void	 Writen(int, void *, size_t);
extern ssize_t	 Readn(int, void *, size_t);


/*********  wrappthread.c  *********/

extern void	Pthread_create(pthread_t *, const pthread_attr_t *,
                                void * (*)(void *), void *);
extern void	Pthread_join(pthread_t, void **);
extern void	Pthread_detach(pthread_t);
extern void	Pthread_kill(pthread_t, int);

extern void	Pthread_mutexattr_init(pthread_mutexattr_t *);
#ifdef	_POSIX_THREAD_PROCESS_SHARED
extern void	Pthread_mutexattr_setpshared(pthread_mutexattr_t *, int);
#endif
extern void	Pthread_mutex_init(pthread_mutex_t *, pthread_mutexattr_t *);
extern void	Pthread_mutex_lock(pthread_mutex_t *);
extern void	Pthread_mutex_unlock(pthread_mutex_t *);

extern void	Pthread_cond_broadcast(pthread_cond_t *);
extern void	Pthread_cond_signal(pthread_cond_t *);
extern void	Pthread_cond_wait(pthread_cond_t *, pthread_mutex_t *);
extern void	Pthread_cond_timedwait(pthread_cond_t *, pthread_mutex_t *,\
				       const struct timespec *);

extern void	Pthread_key_create(pthread_key_t *, void (*)(void *));
extern void	Pthread_setspecific(pthread_key_t, const void *);
extern void	Pthread_once(pthread_once_t *, void (*)(void));

/************* wraplib.c ************/

extern void*	Calloc(size_t, size_t);
extern void	Close(int fd);
extern void	Dup2(int fd1, int fd2);
extern int	Fcntl(int fd, int cmd, int arg);
extern void	Gettimeofday(struct timeval *tv, void *foo);
extern int	Ioctl(int fd, int request, void *arg);
extern pid_t	Fork(void);
extern void*	Malloc(size_t);
extern void	Mktemp(char *temp);
extern void*	Mmap(void *addr, size_t len, int prot, int flags, \
		     int fd, off_t offset);
extern int	Open(const char *pathname, int oflag, mode_t mode);
extern void	Pipe(int *fds);
extern ssize_t	Read(int fd, void *ptr, size_t nbytes);
extern void	Sigaddset(sigset_t *set, int signo);
extern void	Sigdelset(sigset_t *set, int signo);
extern void	Sigemptyset(sigset_t *set);
extern void	Sigfillset(sigset_t *set);
extern int	Sigismember(const sigset_t *set, int signo);
extern void	Sigpending(sigset_t *set);
extern void	Sigprocmask(int how, const sigset_t *set, sigset_t *oset);
extern char*	Strdup(const char *str);
extern long	Sysconf(int name);
#ifdef	HAVE_SYS_SYSCTL_H
extern void	Sysctl(int *name, u_int namelen, void *oldp, size_t *oldlenp,\
		       void *newp, size_t newlen);
#endif
extern void	Unlink(const char *pathname);
extern pid_t	Wait(int *iptr);
extern pid_t	Waitpid(pid_t pid, int *iptr, int options);
extern void	Write(int fd, void *ptr, size_t nbytes);

/************   wrapsock.c   ************/

extern int	Accept(int fd, struct sockaddr *sa, socklen_t *salenptr);
extern void	Bind(int fd, const struct sockaddr *sa, socklen_t salen);
extern void	Connect(int fd, const struct sockaddr *sa, socklen_t salen);
extern void	Getpeername(int fd, struct sockaddr *sa, socklen_t *salenptr);
extern void	Getsockname(int fd, struct sockaddr *sa, socklen_t *salenptr);
extern void	Getsockopt(int fd, int level, int optname, void *optval, \
		   socklen_t *optlenptr);
extern void	Listen(int fd, int backlog);
#ifdef	HAVE_POLL
extern int	Poll(struct pollfd *fdarray, unsigned long nfds, int timeout);
#endif
extern ssize_t	Recv(int fd, void* buf, size_t nbytes, int flags);
extern ssize_t	Recvfrom(int fd, void* buf, size_t nbytes, int flags, \
			 struct sockaddr *sa, socklen_t *salenptr);
extern ssize_t	Recvmsg(int fd, struct msghdr *msg, int flags);
extern int	Select(int nfds, fd_set *readfds, fd_set *writefds, \
		       fd_set *exceptfds, struct timeval *timeout);
extern void	Send(int fd, const void* buf, size_t nbytes, int flags);
extern void	Sendto(int fd, const void* buf, size_t nbytes, int flags, \
		       const struct sockaddr *sa, socklen_t salen);
extern void	Sendmsg(int fd, const struct msghdr *msg, int flags);
extern void	Setsockopt(int fd, int level, int optname, \
			   const void *optval, socklen_t optlen);
extern void	Shutdown(int fd, int how);
extern int	Socket(int family, int type, int protocol);
extern void	Socketpair(int family, int type, int protocol, int *fd);

#ifdef  __cplusplus
}
#endif

#endif
