/********************************************************************
  wrapsock.c
    VIOSɸѴؿ sock åѡ
*********************************************************************/
#include "vios_lib.h"


int
Accept(int fd, struct sockaddr *sa, socklen_t *salenptr)
{
    int	n;

again:
    if((n = accept(fd, sa, salenptr)) < 0) {
#ifdef	EPROTO
	if(errno == EPROTO || errno == ECONNABORTED)
#else
	if(errno == ECONNABORTED)
#endif
	    goto again;
	else  errs_exit("accept error");
    }
    return(n);
}

void
Bind(int fd, const struct sockaddr *sa, socklen_t salen)
{
    if(bind(fd, sa, salen) < 0) errs_exit("bind error");
}

void
Connect(int fd, const struct sockaddr *sa, socklen_t salen)
{
    if(connect(fd, sa, salen) < 0) errs_exit("connect error");
}

void
Getpeername(int fd, struct sockaddr *sa, socklen_t *salenptr)
{
    /* 	³Ƥ̾ */
    if(getpeername(fd, sa, salenptr) < 0) errs_exit("getpeername error");
}

void
Getsockname(int fd, struct sockaddr *sa, socklen_t *salenptr)
{
    /* åȤ̾(sockaddr) */
    if(getsockname(fd, sa, salenptr) < 0) errs_exit("getsockname error");
}

void
Getsockopt(int fd, int level, int optname, void *optval, socklen_t *optlenptr)
{
    if(getsockopt(fd, level, optname, optval, optlenptr) < 0)
	errs_exit("getsockopt error");
}

void
Listen(int fd, int backlog)
{
    /* LISTENQĶѿꤵƤʤ֤ */
    char* ptr;
    if ((ptr = getenv("LISTENQ")) != NULL) backlog = atoi(ptr);
    
    if (listen(fd, backlog) < 0) errs_exit("listen error");
}

#ifdef	HAVE_POLL
int
Poll(struct pollfd *fdarray, unsigned long nfds, int timeout)
{
    int	n;

    if((n = poll(fdarray, nfds, timeout)) < 0) errs_exit("poll error");
    return(n);
}
#endif

ssize_t
Recv(int fd, void* buf, size_t nbytes, int flags)
{
    ssize_t n;

    if((n = recv(fd, buf, nbytes, flags)) < 0) errs_exit("recv error");
    return(n);
}

ssize_t
Recvfrom(int fd, void* buf, size_t nbytes, int flags,\
		 struct sockaddr *sa, socklen_t *salenptr)
{
    ssize_t n;

    if((n = recvfrom(fd, buf, nbytes, flags, sa, salenptr)) < 0)
	errs_exit("recvfrom error");
    return(n);
}

ssize_t
Recvmsg(int fd, struct msghdr *msg, int flags)
{
    ssize_t n;

    if((n = recvmsg(fd, msg, flags)) < 0) errs_exit("recvmsg error");
    return(n);
}

int
Select(int nfds, fd_set *readfds, fd_set *writefds, fd_set *exceptfds,\
       struct timeval *timeout)
{
    int	n;

    if((n = select(nfds, readfds, writefds, exceptfds, timeout)) < 0)
	errs_exit("select error");
    return(n);	   /* timeoutǤ0ˤʤꤦ */
}

void
Send(int fd, const void* buf, size_t nbytes, int flags)
{
    if(send(fd, buf, nbytes, flags) != nbytes) errs_exit("send error");
}

void
Sendto(int fd, const void* buf, size_t nbytes, int flags, \
	   const struct sockaddr *sa, socklen_t salen)
{
    if(sendto(fd, buf, nbytes, flags, sa, salen) != nbytes)
	errs_exit("sendto error");
}

void
Sendmsg(int fd, const struct msghdr *msg, int flags)
{
    int i;
    ssize_t nbytes = 0; /* ɬ */

    for(i=0; i < msg->msg_iovlen; i++)
	nbytes += msg->msg_iov[i].iov_len;

    if(sendmsg(fd, msg, flags) != nbytes) errs_exit("sendmsg error");
}

void
Setsockopt(int fd, int level, int optname, const void *optval, \
	   socklen_t optlen)
{
    if(setsockopt(fd, level, optname, optval, optlen) < 0)
	errs_exit("setsockopt error");
}

void
Shutdown(int fd, int how)
{
    /* ³ΰǤ롣*/
    if(shutdown(fd, how) < 0) errs_exit("shutdown error");
}

int
Socket(int family, int type, int protocol)
{
    int	n;

    if((n = socket(family, type, protocol)) < 0) errs_exit("socket error");
    return(n);
}

void
Socketpair(int family, int type, int protocol, int *fd)
{
    int	n;

    /* ѥפ(餯Ѥʤ) */
    if((n = socketpair(family, type, protocol, fd)) < 0)
	errs_exit("socketpair error");
}
