/**********************************************************
  vsCube.h
  VIOS 3󥯥饹
***********************************************************/
#include "module.h"
#include "ip.h"

#ifndef __VS_CUBE_H
#define __VS_CUBE_H

template <class T>
class vsCube
{
  protected:
    int		lx;
    int		ly;
    int		lz;

    int		w_chk;

    // ۵ѡ̾parallelʸǤ㳰
    vs_request	req;

    T		GetNow(int x, int y, int z);
    // ٱѡI/EparallelʸǤɡ
    int		b_width;
    int		b_heigh;
    int		b_depth;

    int*	host_cnt;
    int*	wait_cnt;
    vs_io_buf**	  io_buf;
    vs_reqgrp*	send_buf;

    T		GetReq(int x, int y, int z);
    T		SetReq(T val);

    // ֽ񤭹ѡ㳰Ū
    vs_write	wbuf;

  public:
    int		id;

    vs_data*	info;
    T*		dt;

    vsCube();
    vsCube(int width, int heigh, int depth, int def = 0);
    vsCube(vsCube<int>*   orig, int def);
    vsCube(vsCube<FLOAT>* orig, int def);
   ~vsCube();

#define _VS_OPERATE_3D(OP)						     \
    if(w_chk)								     \
	dt[(lz * info->local->heigh + ly) * info->local->width + lx] OP val; \
    else {								     \
	SetReq(val);							     \
    }									     \
    return val

     inline T	operator  =(T val){ _VS_OPERATE_3D(=);  };
     inline T	operator +=(T val){ _VS_OPERATE_3D(+=); };
     inline T	operator -=(T val){ _VS_OPERATE_3D(-=); };
     inline T	operator *=(T val){ _VS_OPERATE_3D(*=); };
     inline T	operator /=(T val){ _VS_OPERATE_3D(/=); };

#undef _VS_OPERATE_3D

    T		 vs_ck (int x, int y, int z); 

    T		 vs_rd (int x, int y, int z);
    T		 vs_rde(int x, int y, int z);
    T		 vs_rdc(int x, int y, int z);

    vsCube<T>&	 vs_wt (int x, int y, int z);
    vsCube<T>&	 vs_wte(int x, int y, int z);
    vsCube<T>&	 vs_wtc(int x, int y, int z);

    vsCube<T>&	 vs_rw (int x, int y, int z);
    vsCube<T>&	 vs_rwe(int x, int y, int z);
    vsCube<T>&	 vs_rwc(int x, int y, int z);

    void	 CubeCopy(vsCube<int>*   src);
    void	 CubeCopy(vsCube<FLOAT>* src);
};

#include	"vsCube_const.h"
#include 	"vsCube_io.h"
#include	"vsCube_comm.h"

#endif
