/*********************************************************************
  vsCube_io.h
  ⥸塼Ǥζ(3)ѥ饹
*********************************************************************/

/*  Υե vsCube.h ǥ󥯥롼ɤޤ  */


/* --------------------  ɤ߹Ѵؿ  -------------------- */

template <class T>
inline T
vsCube<T>::vs_ck(int x, int y, int z)
{
    return ((x >= 0) && (x < info->local->width) && \
	    (y >= 0) && (y < info->local->heigh) && \
	    (z >= 0) && (z < info->local->depth)) ? \
		dt[(z * info->local->heigh + y) * info->local->width + x] \
		                                              : GetReq(x,y,z);
}

template <class T>
inline T
vsCube<T>::vs_rd(int x, int y, int z)
{
    return ((x >= 0) && (x < info->local->width) && \
	    (y >= 0) && (y < info->local->heigh) && \
	    (z >= 0) && (z < info->local->depth)) ? \
		dt[(z * info->local->heigh + y) * info->local->width + x] \
		                                              : GetNow(x,y,z);
}

// parallel_ieѤɤ߹ߴؿ ------------------------------
template <class T>
inline T
vsCube<T>::vs_rde(int x, int y, int z)
{
    return ((x >= 0) && (x < info->local->width) && \
	    (y >= 0) && (y < info->local->heigh) && \
	    (z >= 0) && (z < info->local->depth)) ? \
		dt[(z * info->local->heigh + y) * info->local->width + x] \
		                                              : GetReq(x,y,z);
}

template <class T>
inline T
vsCube<T>::vs_rdc(int x, int y, int z)
{
    return dt[(z * info->local->heigh + y) * info->local->width + x];
}

/* --------------------  񤭹Ѵؿ  -------------------- */
template <class T>
inline vsCube<T>&
vsCube<T>::vs_wt(int x, int y, int z)
{
    w_chk = ((x >= 0) && (x < info->local->width) && \
	     (y >= 0) && (y < info->local->heigh) && \
	     (z >= 0) && (z < info->local->depth)) ? 1 : 0;
    lx = x;  ly = y; lz = z;
    return *this;
}

template <class T>
inline vsCube<T>&
vsCube<T>::vs_wte(int x, int y, int z)
{
    w_chk = ((x >= 0) && (x < info->local->width) && \
	     (y >= 0) && (y < info->local->heigh) && \
	     (z >= 0) && (z < info->local->depth)) ? 1 : 0;
    lx = x;  ly = y; lz = z;
    return *this;
}

template <class T>
inline vsCube<T>&
vsCube<T>::vs_wtc(int x, int y, int z)
{
    w_chk = 1; lx = x;  ly = y; lz = z;
    return *this;
}

template <class T>
inline vsCube<T>&
vsCube<T>::vs_rw(int x, int y, int z)
{
    w_chk = ((x >= 0) && (x < info->local->width) && \
	     (y >= 0) && (y < info->local->heigh) && \
	     (z >= 0) && (z < info->local->depth)) ? 1 : 0;
    lx = x;  ly = y; lz = z;
    return *this;
}

template <class T>
inline vsCube<T>&
vsCube<T>::vs_rwe(int x, int y, int z)
{
    w_chk = ((x >= 0) && (x < info->local->width) && \
	     (y >= 0) && (y < info->local->heigh) && \
	     (z >= 0) && (z < info->local->depth)) ? 1 : 0;
    lx = x;  ly = y; lz = z;
    return *this;
}

template <class T>
inline vsCube<T>&
vsCube<T>::vs_rwc(int x, int y, int z)
{
    w_chk = 1; lx = x;  ly = y; lz = z;
    return *this;
}

/* ------------------------------------------------------------ */
template <class T>
void
vsCube<T>::CubeCopy(vsCube<int>* src)
{
    memcpy(dt, src->dt, info->dsize * sizeof(int));
}

template <class T>
void
vsCube<T>::CubeCopy(vsCube<FLOAT>* src)
{
    memcpy(dt, src->dt, info->dsize * sizeof(FLOAT));
}

