/**********************************************************
  vsCube_opt.h
  VIOS 3󥯥饹( 3ʬ )
***********************************************************/
#include "vsCube.h"

#ifndef __VS_CUBE_OPT_H
#define __VS_CUBE_OPT_H

template <class T>
class vsCube_opt : public vsCube<T>
{
  public:
    vsCube_opt() : vsCube<T>(){ };

    vsCube_opt(vsCube<int>*   orig, int def = 0)
    {
	info	= orig->info;
	dt 	= new T[info->dsize];
	memset(dt, def, info->dsize * sizeof(int));
    };

    vsCube_opt(vsCube<FLOAT>* orig, int def = 0)
    {
	info	= orig->info;
	dt 	= new T[info->dsize];
	memset(dt, def, info->dsize * sizeof(FLOAT));
    };

#define _VS_OPERATE_3D(OP)						 \
    dt[(lz * info->local->heigh + ly) * info->local->width + lx] OP val; \
    return val

    inline T  operator  =(T val){ _VS_OPERATE_3D(=);  };
    inline T  operator +=(T val){ _VS_OPERATE_3D(+=); };
    inline T  operator -=(T val){ _VS_OPERATE_3D(-=); };
    inline T  operator *=(T val){ _VS_OPERATE_3D(*=); };
    inline T  operator /=(T val){ _VS_OPERATE_3D(/=); };

#undef  _VS_OPERATE_3D


    inline T	  vs_ck (int x, int y, int z)
         { return dt[(z * info->local->heigh + y) * info->local->width + x]; };
    inline T	  vs_rd (int x, int y, int z)
         { return dt[(z * info->local->heigh + y) * info->local->width + x]; };
    inline T	  vs_rde(int x, int y, int z)
         { return dt[(z * info->local->heigh + y) * info->local->width + x]; };
    inline T	  vs_rdc(int x, int y, int z)
         { return dt[(z * info->local->heigh + y) * info->local->width + x]; };

    inline vsCube_opt<T>&
	 vs_wt (int x, int y, int z){ lx = x;  ly = y; lz = z; return *this; };
    inline vsCube_opt<T>&
         vs_wte(int x, int y, int z){ lx = x;  ly = y; lz = z; return *this; };
    inline vsCube_opt<T>&
         vs_wtc(int x, int y, int z){ lx = x;  ly = y; lz = z; return *this; };
    inline vsCube_opt<T>&
         vs_rw (int x, int y, int z){ lx = x;  ly = y; lz = z; return *this; };
    inline vsCube_opt<T>&
         vs_rwe(int x, int y, int z){ lx = x;  ly = y; lz = z; return *this; };
    inline vsCube_opt<T>&
         vs_rwc(int x, int y, int z){ lx = x;  ly = y; lz = z; return *this; };

};


#endif
