/**********************************************************
  vsvalue_opt.h
  VIOS 1󥯥饹
***********************************************************/
#include "vsvalue.h"

#ifndef __VS_VALUE_OPT_H
#define __VS_VALUE_OPT_H

template <class T>
class vsvalue_opt : public vsvalue<T>
{
  public:
    vsvalue_opt() : vsvalue<T>(){ };

     vsvalue_opt(vsvalue<int>*   orig, int def = 0)
     {
	 info	= orig->info;
	 dt	= new T[info->dsize];
	 memset(dt, def, info->dsize * sizeof(int));
     };
     vsvalue_opt(vsvalue<FLOAT>* orig, int def = 0)
     {
	 info	= orig->info;
	 df	= new T[info->dsize];
	 memset(dt, def, info->dsize * sizeof(FLOAT));
     };

#define _VS_OPERATE_1D(OP)			\
    dt[lx] OP val;				\
    return val;

    inline T operator  =(T val){ _VS_OPERATE_1D(=)  };
    inline T operator +=(T val){ _VS_OPERATE_1D(+=) };
    inline T operator -=(T val){ _VS_OPERATE_1D(-=) };
    inline T operator *=(T val){ _VS_OPERATE_1D(*=) };
    inline T operator /=(T val){ _VS_OPERATE_1D(/=) };

#undef _VS_OPERATE_1D

    inline T        vs_ck (int x){            return dt[x];   };

    inline T        vs_rd (int x){            return dt[x];   };
    inline T        vs_rde(int x){            return dt[x];   };
    inline T        vs_rdc(int x){            return dt[x];   };

    inline vsvalue_opt<T>&
	            vs_wt (int x){    lx = x; return *this;   };
    inline vsvalue_opt<T>&
	            vs_wte(int x){    lx = x; return *this;   };
    inline vsvalue_opt<T>&
	            vs_wtc(int x){    lx = x; return *this;   };
    inline vsvalue_opt<T>&
	            vs_rw (int x){    lx = x; return *this;   };
    inline vsvalue_opt<T>&
	            vs_rwe(int x){    lx = x; return *this;   };
    inline vsvalue_opt<T>&
	            vs_rwc(int x){    lx = x; return *this;   };

};



#endif
