%{
/******************************************************
 pp.l
 moduleΤΥץץåʻ
 ******************************************************/

#ifdef DEBUG
#define token(t) printf("%-12s is \"%s\" (lval=%d)\n", #t,yytext, yylval.id);
#else
#define token(t) { strcpy(store, yytext); return(t); }
#endif


void	insert();
int	line;
int	lflg;
%}
%x DEFINE STRING C_COMM CPP_COMM NO_RULE
ND				[a-zA-Z_]
DG				[0-9]
%%
^"#" {
    fprintf(yyout,"#"); BEGIN DEFINE;
}
"/*"			   /* */BEGIN C_COMM;
"//"			   	BEGIN CPP_COMM;
"!"				token (READ_OP)
"&&"				token (READ_OP)
"&"			       	token (READ_OP)
"|"				token (READ_OP)
"^"				token (READ_OP)
"~"				token (READ_OP)
"*"				token (READ_OP)
"+"				token (READ_OP)
"-"				token (READ_OP)
"/"				token (READ_OP)
"%"				token (READ_OP)
"<"				token (READ_OP)
"<="				token (READ_OP)
"<<"				token (READ_OP)
"=="				token (READ_OP)
"!="				token (READ_OP)
">"				token (READ_OP)
">="				token (READ_OP)
">>"				token (READ_OP)
"?"				token (READ_OP)
"++"				token (READ_OP)
"--"				token (READ_OP)
"("				token (LP)
")"				token (RP)
"{"				token (LC)
"}"				token (RC)
"[["				token (LLB)
"["				token (LB)
"]]"				token (RRB)
"]"	{
    if(now_cnt > 0) {
	token ((--now_cnt)?  (RB_DUMMY) : (RB))
    } else {
	token (RB)
    }
}
"="				token  (WRITE_OP)
"&="				token (RWRITE_OP)
"^="				token (RWRITE_OP)
"|="				token (RWRITE_OP)
"+="				token (RWRITE_OP)
"-="				token (RWRITE_OP)
"/="				token (RWRITE_OP)
"*="				token (RWRITE_OP)
"%="				token (RWRITE_OP)
"<<="				token (RWRITE_OP)
">>="				token (RWRITE_OP)
","				token (CM)
":"				token (CN)
";"				token (SM)
"->"				token (ARROW)
[ \t]				insert();
\n	{
    ++line;
    if(lflg && (now_cnt <= 0)) {
	fprintf(yyout,"\n#line %d", line);
	lflg = 0;
    }
    insert();
}
\"			   /*"*/strcpy(store,yytext); BEGIN STRING;
"vs_module"			token (MODULE)
"iCube"				token (ICUB)
"fCube"				token (FCUB)
"iCube_opt"			token (ICUB_O)
"fCube_opt"			token (FCUB_O)
"iImage"			token (IIMG)
"fImage"			token (FIMG)
"iImage_opt"			token (IIMG_O)
"fImage_opt"			token (FIMG_O)
"ivalue"			token (IVAL)
"fvalue"			token (FVAL)
"ivalue_opt"			token (IVAL_O)
"fvalue_opt"			token (FVAL_O)
"comm_in"			token (COMM_STAT)
"comm_out"			token (COMM_STAT)
"float"                         strcpy(store , "FLOAT");return(NOP);
"double"                         strcpy(store , "DOUBLE");return(NOP);
"parallel"|"parallel_ie"  {
    strcpy(store, yytext);
    yylval.str = store;
    lflg = 1; token (NO_VAL);
}
{ND}({ND}|{DG})* {
    /* * * ʸ̤ * * */
    if(find(yytext) > 0) {
	int i;
	for(i=0; i< w_num; i++) {
	    if(!strcmp(yytext, wtable[i])) {
		token (windex[i]);
	    }
	}
    } else {
	token (NO_VAL);
    }
}
.				insert();


<NO_RULE>a /*** defineޤ֤б뤳 ***/

<DEFINE>\n 		    	fprintf(yyout,"\n"); BEGIN INITIAL; ++line; 
<DEFINE>.			fprintf(yyout,"%c",yytext[0]);


<NO_RULE>b /**** ץ󥹤ʤɤбƤʤ ****/

<STRING>\" {
    /*"*/BEGIN INITIAL;
	 strcat(store, yytext); return (STR);
}
<STRING>\n			strcat(store, "\n"); ++line;
<STRING>.	 		strcat(store, yytext);


<C_COMM>"*/"			BEGIN INITIAL;
<C_COMM>\n			++line;
<C_COMM>.			;


<CPP_COMM>\n			BEGIN INITIAL; fprintf(yyout,"\n"); ++line;
<CPP_COMM>.			;
%%

void
insert()
{
    if(now_cnt > 0) {
	strcat(phase,yytext);
    } else {
	fprintf(yyout,"%c",yytext[0]);
    }
}
int
find(char* s)
{
    int i;

    for(i=0;i<w_num;i++) {
	if(!strcmp(s, wtable[i])) {
	    yylval.id = i;
	    return i;
	}
    }
    strcpy(store, s); yylval.str = store;
    return -1;
}

int
main(int argc, char* argv[])
{
    FILE* infile;

    if(argc != 2) {
	fprintf(stderr,"usage: %s \"module_file\"\n", argv[0]);
	return 1;
    }
    if(!(yyin = fopen(argv[1], "r"))) {
	fprintf(stderr,"Cannot open file:%s\n", argv[1]);
	return 1;
    }
    yyout = stdout;

    fprintf(yyout,"#include \"vios_module.h\"\n");
    fprintf(yyout,"#line 1 \"%s\"\n", argv[1]);
    line = 1;
    lflg = 0;
    while(yyparse());

    fclose(yyin);
    return 0;
}
