/*********************************************************************
  ip.h
    IP 饹ΤȤʤ
*********************************************************************/
#include "ip_struct.h"

#ifndef __IP_H
#define __IP_H


class Ip
{
    int cnt;

    int			om_fd;		    // OMȤΥǥץ
    int			readfd[MAX_HOST];   // IPȤΥǥץ
    int 		wrtefd[MAX_HOST];

    int			conn_num;
    pthread_t		conn_id1;	    // ³å
    pthread_t		conn_id2;	    // ³å

    int			sync_flg;
    int			sync_cnt;

    vs_data*	       	data;		    // ѿθ
    vs_dtype		cell;

    pthread_mutex_t	slock;		    // SyncΤ
    pthread_cond_t	scond;

    int			base1D;		    // comm̿
    int			base2D[2];
    int			base3D[3];

    void (Ip::*Recv[MAX_PROTO])();
    void (Ip::*RecvIP[MAX_PROTO])(int host);    

    inline void Protocol(int send_id)
    {    Writen(om_fd, (void*)&send_id, sizeof(int));    };    

    void	CheckNext();
    // ˴ؤؿ
    void	ReqConnectStart();
    void	ReqInterConnect();
    void	ReqModule();

    void	RecvImg();
    void	RecvCub();
    void	RecvValue();

    void	ReqEnd();
    void	ReqSync();
    void	ReqUnion();
    void	ReqGather();
    void	ReqInfo();

    // ip <=> ip
    void	ReqSet    (int host);
    void	RetComm   (int host);

    void	ReqCell   (int host);
    void	RetCell   (int host);
    void	ReqCell_nw(int host);
    void	RetCell_nw(int host);

    void	ReqCache(int host);
    void	RetCache(int host);


  public:
    int		id;

     Ip(int fd);
    ~Ip(){};

    void	ConnectStart();
    void	InterConnect1();
    void	InterConnect2();


    // ˴ؤؿ
    void	SendDone();
    void	SendSync();
    void	SendSyncCache(vs_data* ptr, int vid);
    void	SendUnion(vs_data* ptr, int vid, int type);
    void	SendVote(vs_data* ptr, int vid, int pos,   int val);
    void	SendVote(vs_data* ptr, int vid, int pos, FLOAT val);

    void	GetReq();
    void	SetReq (int host, vs_write*   req);
    int		iGetNow(int host, vs_request* req);
    FLOAT	fGetNow(int host, vs_request* req);


    void	ReqComm(int host, int src, int dist, int   val);
    void	ReqComm(int host, int src, int dist, FLOAT val);

    void	comm_ck (int s_x, int*   val, int d_x);
    void	comm_in (int s_x, int*   val, int d_x);
    void	comm_out(int d_x, int    val, int s_x);
    void	comm_ck (int s_x, FLOAT* val, int d_x);
    void	comm_in (int s_x, FLOAT* val, int d_x);
    void	comm_out(int d_x, FLOAT  val, int s_x);

    void	comm_ck (int s_x, int s_y, int*   val, int d_x, int d_y);
    void	comm_in (int s_x, int s_y, int*   val, int d_x, int d_y);
    void	comm_out(int d_x, int d_y, int    val, int s_x, int s_y);
    void	comm_ck (int s_x, int s_y, FLOAT* val, int d_x, int d_y);
    void	comm_in (int s_x, int s_y, FLOAT* val, int d_x, int d_y);
    void	comm_out(int d_x, int d_y, FLOAT  val, int s_x, int s_y);

    void	comm_ck (int s_x, int s_y, int s_z, int*   val, \
			 int d_x, int d_y, int d_z);
    void	comm_in (int s_x, int s_y, int s_z, int*   val, \
			 int d_x, int d_y, int d_z);
    void	comm_out(int d_x, int d_y, int d_z, int    val, \
			 int s_x, int s_y, int s_z);
    void	comm_ck (int s_x, int s_y, int s_z, FLOAT* val, \
			 int d_x, int d_y, int d_z);
    void	comm_in (int s_x, int s_y, int s_z, FLOAT* val, \
			 int d_x, int d_y, int d_z);
    void	comm_out(int d_x, int d_y, int d_z, FLOAT  val, \
			 int s_x, int s_y, int s_z);

    inline void	comm_no (int d_x,                   int    val, \
			 int s_x){};
    inline void	comm_no (int d_x, int d_y,          int    val, \
			 int s_x, int s_y){};
    inline void	comm_no (int d_x, int d_y, int d_z, int    val, \
			 int s_x, int s_y, int s_z){};
    inline void	comm_no (int d_x,                   FLOAT  val, \
			 int s_x){};
    inline void	comm_no (int d_x, int d_y,          FLOAT  val, \
			 int s_x, int s_y){};
    inline void	comm_no (int d_x, int d_y, int d_z, FLOAT  val, \
			 int s_x, int s_y, int s_z){};


    // ¾δؿǰư or ѹ
    void	SetDike(int dike, vs_data* ptr);
};

extern Ip*	ip;		// 

#endif
