/********************************************************************
  ip_cache.cc
    IP <=> IP ̿
*********************************************************************/
#include <sys/types.h>
#include <sys/socket.h>

#include "ip.h"
#include "ip_table.h"
#include "module.h"



// ׻񤭹׵  --------------------------------------------
void
Ip::ReqSet(int host)
{
    vs_write val;
    Readn(readfd[host], &(val.id), sizeof(vs_write) - sizeof(int));

    vs_data* ptr = module_tab.argv[val.id];

    int x,y,z;
    switch(ptr->type) {
      case INT:
	(  (int*)ptr->val)[x - ptr->div_info[0].index] = val.dt.ival;
	break;
      case FLT:
	((FLOAT*)ptr->val)[x - ptr->div_info[0].index] = val.dt.fval;
	break;
      case iIMG:
	x = (val.index & 0xffff) - ptr->div_info[0].index;
	y = (val.index >> 16   ) - ptr->div_info[1].index;
	(  (int*)ptr->val)[y * ptr->local->width + x] = val.dt.ival;
	break;
      case fIMG:
	x = (val.index & 0xffff) - ptr->div_info[0].index;
	y = (val.index >> 16   ) - ptr->div_info[1].index;
	((FLOAT*)ptr->val)[y * ptr->local->width + x] = val.dt.fval;
	break;
      case iCUB:
	x =  (val.index        & 0x3ff) - ptr->div_info[0].index;
	y = ((val.index >> 10) & 0x3ff) - ptr->div_info[1].index;
	z =  (val.index >> 20)          - ptr->div_info[2].index;
	(  (int*)ptr->val)[(z * ptr->local->heigh + y) \
			      * ptr->local->width + x] = val.dt.ival;
	break;
      case fCUB:
	x =  (val.index        & 0x3ff) - ptr->div_info[0].index;
	y = ((val.index >> 10) & 0x3ff) - ptr->div_info[1].index;
	z =  (val.index >> 20)          - ptr->div_info[2].index;
	((FLOAT*)ptr->val)[(z * ptr->local->heigh + y) \
			      * ptr->local->width + x] = val.dt.fval;
	break;
    }
}


// I/E Non-Wait ׵ ---------------------------------------------
void
Ip::ReqCell_nw(int host)
{
    int size;
    Readn(readfd[host], &size, sizeof(int));

    vs_reqgrp* req = new vs_reqgrp[size];
    vs_retgrp* ret = new vs_retgrp[size];

    Readn(readfd[host], req, sizeof(vs_reqgrp) * size);

    for(int i=0; i< size; i++) {
	int x, y, z;
	vs_data* ptr = module_tab.argv[req[i].id];
	
	ret[i].id    = req[i].id;
	ret[i].index = req[i].index;

	switch(ptr->type) {
	  case INT:
	    ret[i].dt.ival = *((int*)ptr->val \
			       + req[i].index - ptr->div_info[0].index);
	    break;
	  case FLT:
	    ret[i].dt.fval = *((FLOAT*)ptr->val \
			       + req[i].index - ptr->div_info[0].index);
	    break;
	  case iIMG:
	    x = (req[i].index & 0xffff) - ptr->div_info[0].index;
	    y = (req[i].index >>16    ) - ptr->div_info[1].index;

	    ret[i].dt.ival =   *((int*)ptr->val \
				 + y * ptr->local->width + x);
	    break;	
	  case fIMG:
	    x = (req[i].index & 0xffff) - ptr->div_info[0].index;
	    y = (req[i].index >>16    ) - ptr->div_info[1].index;

	    ret[i].dt.fval = *((FLOAT*)ptr->val \
			         + y * ptr->local->width + x);
	    break;
	  case iCUB:
	    x =  (req[i].index       & 0x3ff) - ptr->div_info[0].index;
	    y = ((req[i].index >>10) & 0x3ff) - ptr->div_info[1].index;
	    z =  (req[i].index >>20)          - ptr->div_info[2].index;

	    ret[i].dt.ival =   *((int*)ptr->val + \
				 (z * ptr->local->heigh + y) \
				    * ptr->local->width + x);
	    break;	
	  case fCUB:
	    x =  (req[i].index       & 0x3ff) - ptr->div_info[0].index;
	    y = ((req[i].index >>10) & 0x3ff) - ptr->div_info[1].index;
	    z =  (req[i].index >>20)          - ptr->div_info[2].index;

	    ret[i].dt.fval =   *((FLOAT*)ptr->val + \
				 (z * ptr->local->heigh + y) \
				    * ptr->local->width + x);

	    break;
	}
    }
    int protocol = pRetCell_nw;
    Writen(readfd[host], &protocol, sizeof(int));
    Writen(readfd[host], &size,     sizeof(int));
    Writen(readfd[host], ret,	    sizeof(vs_retgrp) * size);
}

void
Ip::RetCell_nw(int host)
{
    int size;
    Readn(wrtefd[host], &size, sizeof(int));

    vs_retgrp* ret = new vs_retgrp[size];
    Readn(wrtefd[host], ret, sizeof(vs_retgrp) * size);

    for(int i=0; i<size; i++) {
	int x, y, z;
	vs_data* ptr = module_tab.argv[ret[i].id];

	vs_io_buf* q;
	switch(ptr->type) {
	  case INT:	
	  case FLT:
	    q = module_tab.io_buf[ret[i].index & IO_KEY];
	  case iIMG:
	  case fIMG:
	    x = ret[i].index & 0xffff;
	    y = ret[i].index >> 16;
	    q = module_tab.io_buf[(x + y)      & IO_KEY];
	    break;
	  case iCUB:
	  case fCUB:
	    x =  ret[i].index & 0x3ff;
	    y = (ret[i].index >>10) & 0x3ff;
	    z =  ret[i].index >>20;
	    q = module_tab.io_buf[(x + y + z)  & IO_KEY];
	    break;
	}
	while((q->index != ret[i].index) || (q->id != ret[i].id))
	    q = q->next;

	q->dt   = ret[i].dt;
	q->flag = 1;
    }
}



// ̾ʸγǡ׵㳰Ūȯ -----------------------------
void
Ip::ReqCell(int host)
{
    vs_request req;
    Readn(readfd[host], &req.id, sizeof(vs_request) - sizeof(int));

    int x, y, z;
    vs_data* ptr  = module_tab.argv[req.id];

    vs_return ret;
    ret.protocol = pRetCell;

    switch(ptr->type){
      case INT:
	ret.dt.ival =   *((int*)ptr->val + req.index - ptr->div_info[0].index);
	break;
      case FLT:
	ret.dt.fval = *((FLOAT*)ptr->val + req.index - ptr->div_info[0].index);
	break;
      case iIMG:
	x = (req.index & 0xffff) - ptr->div_info[0].index;
	y = (req.index >> 16   ) - ptr->div_info[1].index;
	ret.dt.ival =   *((int*)ptr->val + y * ptr->local->width + x);
	break;
      case fIMG:
	x = (req.index & 0xffff) - ptr->div_info[0].index;
	y = (req.index >> 16   ) - ptr->div_info[1].index;
	ret.dt.fval = *((FLOAT*)ptr->val + y * ptr->local->width + x);
	break;
      case iCUB:
	x =  (req.index       & 0x3ff) - ptr->div_info[0].index;
	y = ((req.index >>10) & 0x3ff) - ptr->div_info[1].index;
	z =  (req.index >>20)          - ptr->div_info[2].index;
	ret.dt.ival =   *((int*)ptr->val + (z * ptr->local->heigh + y) \
					      * ptr->local->width + x);
	break;
      case fCUB:
	x =  (req.index       & 0x3ff) - ptr->div_info[0].index;
	y = ((req.index >>10) & 0x3ff) - ptr->div_info[1].index;
	z =  (req.index >>20)          - ptr->div_info[2].index;
	ret.dt.fval = *((FLOAT*)ptr->val + (z * ptr->local->heigh + y) \
					      * ptr->local->width + x);
	break;
    }
    Writen(wrtefd[host], &ret, sizeof(vs_return));
}

void
Ip::RetCell(int host)
{
    Readn(readfd[host], &cell,  sizeof(vs_dtype));
    Pthread_cond_broadcast(&exec_info.cond);
}
