/*********************************************************************
  generator.cc
  VPE-i (main󥿡ץ꥿) ڤ
*********************************************************************/
#include "lang.h"
#include "vios_run.h"
#include "om_table.h"
#include "om_table_sub.h"
#include "generator.h"
#include "interpreter.h"

//#define _VS_INTER_PRINT	1	// ǥХåե饰




// դؿ ---------------------------------------------------


// iPUSH, fPUSH, sPUSH -------------------------------
leaf*
Generator::make(int type, vs_sub_dt* sb)
{
    now        = new leaf;
    now->type  = type;
    now->sb    = sb;
    now->right = NULL;
    now->left  = NULL;

    return now;
}
// iv1PUSH, fv1PUSH, ivPUSH, fvPUSH, svPUSH ----------
// ip1PUSH, fp1PUSH, ipPUSH, fpPUSH, spPUSH ----------
leaf*
Generator::make(int type, vs_data* dt)
{
    now        = new leaf;
    now->type  = type;
    now->dt    = dt;
    now->right = NULL;
    now->left  = NULL;

    return now;
}

// ʹߤ̿ϡ֥˷Ƚ꤬ɬ
//
// INC, DEC, MIN, ѷ(INT_VAL, FLT) -----------------
leaf*
Generator::make(int type, leaf* left)
{
    now        = new leaf;
    now->type  = type;
    now->left  = left;
    now->right = NULL;

    return now;
}
// iPOP, fPOP, i1POP, f1POP ----------------------------
// FNC
// MUL, DIV, MOD, ADD, SUB
// GTR, GEQ, EQL, NEQ, OR, AND, NOP(ʸ)
// ivXADDR, fvXADDR, ivYADDR, fvYADDR, ivZADDR, fvZADDR
// ipXADDR, fpXADDR, ipYADDR, fpYADDR, ipZADDR, fpZADDR
leaf*
Generator::make(int type, leaf* left, leaf* right)
{
    now        = new leaf;
    now->type  = type;
    now->left  = left;
    now->right = right;

    return now;
}



// (FNC sb) -------------------------------------------
void
Generator::generate(int op, int type, int argc)
{
    if(++pc >= MAX_CODE) {
	fprintf(stderr, "1 line is too long. (;__;)\n");
	longjmp(END_OF_FILES, 0);
    }
    code_area[pc].op = type;
    code_area[pc].sb.vl.ival = argc;

#ifdef _VS_INTER_PRINT
    switch(type) {
      case iPUT:
	fprintf(stderr,"iPUT\t%d\n", argc);
	break;
      case fPUT:
	fprintf(stderr,"fPUT\t%d\n", argc);
	break;
      case sPUT:
	fprintf(stderr,"sPUT\t%d\n", argc);
	break;
      case SET:
	fprintf(stderr,"SET\t%d\n",  argc);
	break;
    }
#endif
}

// ʸڤ֥ɤѹ  --------------------------------------

void
Generator::genelist(leaf* p)
{
    if(p == NULL) return;
    if(p->left)   genelist(p->left);
    if(p->right)  genelist(p->right);

    switch(p->type) {
      case iPUSH:
      case sPUSH:
      case svPUSH:
	generate(p->type, p->sb);	// 黻פ"Ѳ"ʤ
	break;
      case fPUSH:
	generate(p->type, p->sb);	// 黻פfloat
	tflag = 1;
	break;
      case ivPUSH:
      case iv1PUSH:
      case ipPUSH:			// pPUSHϱ黻פ˱ƶʤ
      case ip1PUSH:
      case fpPUSH:
      case fp1PUSH:
      case spPUSH:
	generate(p->type, p->dt);
	break;
      case fvPUSH:
      case fv1PUSH:
	generate(p->type, p->dt);
	tflag = 1;
	break;
      case iPOP:
      case fPOP:
      case i1POP:
      case f1POP:
	generate(p->type);		// äƤͤѿ̿
	tflag = 0;			// Ƚ
	break;
      case INT:
	generate(p->type);
	tflag = 0;
	break;
      case FLT:
	generate(p->type);
	tflag = 1;
	break;
      case NOP: break;			// ά
      default :
	generate(p->type);
      }
   delete p;				// 򤷤ʤ顣
}


// ֥ɤ  -------------------------------------------------

// REG0, 1, 2, 3 ----------------------------------
void
Generator::generate(int op, int type, vs_sub_dt* sb)
{
    if(++pc >= MAX_CODE) {
	fprintf(stderr, "1 line is too long. (;__;)\n");
	longjmp(END_OF_FILES, 0);
    }
    code_area[pc].op = op;
    code_area[pc].sb.vl.sval = sb->dt.sval;
    code_area[pc].sb.ag.dt   = (vs_data*)type;	// ̵


#ifdef _VS_INTER_PRINT
    switch(op) {
      case REG0:
	fprintf(stderr,"REG0\t%s\n", sb->dt.sval);
	break;
      case REG1:
	fprintf(stderr,"REG1\t%s\n", sb->dt.sval);
	break;
      case REG2:
	fprintf(stderr,"REG2\t%s\n", sb->dt.sval);
	break;
      case REG3:
	fprintf(stderr,"REG3\t%s\n", sb->dt.sval);
    }
#endif
}

// (LBL, int) (JPF int) (JMP int) ---------------------
void
Generator::generate(int op, int lb)
{
    if(++pc >= MAX_CODE) {
	fprintf(stderr, "1 line is too long. (;;)\n");
	longjmp(END_OF_FILES, 0);
    }
    code_area[pc].op = op;
    code_area[pc].sb.vl.ival = lb;

#ifdef _VS_INTER_PRINT
    switch(op) {
      case LBL:
	fprintf(stderr,"LBL\t%d\n", lb);
	break;
      case JPF:
	fprintf(stderr,"JPF\t%d\n", lb);
	break;
      case JMP:
	fprintf(stderr,"JMP\t%d\n", lb);
    }
#endif
}

// ƤӽФΤ -------------------------

// iPUSH, fPUSH, sPUSH, svPUSH ------------------------
void
Generator::generate(int op, vs_sub_dt* sb)
{
    if(++pc >= MAX_CODE) {
	fprintf(stderr, "1 line is too long. (;;)\n");
	longjmp(END_OF_FILES, 0);
    }
    code_area[pc].op = op;
    code_area[pc].sb.ag.sb = sb;


#ifdef _VS_INTER_PRINT
    switch(op) {
      case iPUSH:
	fprintf(stderr,"iPUSH\t%d\n",  code_area[pc].sb.ag.sb->dt.ival);
	break;
      case fPUSH:
	fprintf(stderr,"fPUSH\t%f\n", sb->dt.fval);
	break;
      case sPUSH:
	fprintf(stderr,"sPUSH\t%s\n", sb->dt.sval);
	break;
      case svPUSH:
	fprintf(stderr,"svPUSH\t%s\n", sb->dt.sval);
    }
#endif
}

// ivPUSH, iv1PUSH, fvPUSH, fv1PUSH ------------------
// ipPUSH, ip1PUSH, fpPUSH, fp1PUSH, spPUSH ----------
void
Generator::generate(int op, vs_data* dt)
{
    if(++pc >= MAX_CODE) {
	fprintf(stderr, "1 line is too long. (;;)\n");
	longjmp(END_OF_FILES, 0);
    }
    code_area[pc].op = op;
    code_area[pc].sb.ag.dt = dt;


#ifdef _VS_INTER_PRINT
    switch(op) {
      case ivPUSH:
	fprintf(stderr,"ivPUSH\t%s\n", dt->name);
	break;
      case iv1PUSH:
	fprintf(stderr,"iv1PUSH\t%s\n", dt->name);
	break;
      case fvPUSH:
	fprintf(stderr,"fvPUSH\t%s\n", dt->name);
	break;
      case fv1PUSH:
	fprintf(stderr,"fv1PUSH\t%s\n", dt->name);
	break;
      case ipPUSH:
	fprintf(stderr,"ipPUSH\t%s\n", dt->name);
	break;
      case ip1PUSH:
	fprintf(stderr,"ip1PUSH\t%s\n", dt->name);
	break;
      case fpPUSH:
	fprintf(stderr,"fpPUSH\t%s\n", dt->name);
	break;
      case fp1PUSH:
	fprintf(stderr,"fp1PUSH\t%s\n", dt->name);
	break;
      case spPUSH:
	fprintf(stderr,"spPUSH\t%s\n", dt->name);
    }
#endif
}

// ¾η׻̿  ----------------------------------

// ѷ(INT, FLT),  NOP(ʸ)
// iPOP, fPOP, i1POP, f1POP
// INC, DEC, MIN, 
// MUL, DIV, MOD, ADD, SUB, 
// GTR, GEQ, EQL, NEQ, OR, AND,
// ivXADDR, fvXADDR, ivYADDR, fvYADDR, ivZADDR, fvZADDR
// ipXADDR, fpXADDR, ipYADDR, fpYADDR, ipZADDR, fpZADDR
void
Generator::generate(int op)
{
    if(++pc >= MAX_CODE) {
	fprintf(stderr, "1 line is too long. (;;)\n");
	longjmp(END_OF_FILES, 0);
    }

    if(!tflag) { 	// integer Ф *********************
	switch(op) {
	  case iPOP:
	    code_area[pc].op = iiPOP;
	    break;
	  case fPOP:
	    code_area[pc].op = ifPOP;
	    break;
	  case i1POP:
	    code_area[pc].op = ii1POP;
	    break;
	  case f1POP:
	    code_area[pc].op = if1POP;
	    break;
	  case INT:
	    code_area[pc].op = iINT;
	    break;
	  case FLT:
	    code_area[pc].op = iFLT;
	    break;
	  case INC:
	    code_area[pc].op = iINC;
	    break;
	  case DEC:
	    code_area[pc].op = iDEC;
	    break;
	  case MIN:
	    code_area[pc].op = iMIN;
	    break;
	  case MUL:
	    code_area[pc].op = iMUL;
	    break;
	  case DIV:
	    code_area[pc].op = iDIV;
	    break;
	  case MOD:
	    code_area[pc].op = iMOD;
	    break;
	  case ADD:
	    code_area[pc].op = iADD;
	    break;
	  case SUB:
	    code_area[pc].op = iSUB;
	    break;
	  case GTR:
	    code_area[pc].op = iGTR;
	    break;
	  case GEQ:
	    code_area[pc].op = iGEQ;
	    break;
	  case EQL:
	    code_area[pc].op = iEQL;
	    break;
	  case NEQ:
	    code_area[pc].op = iNEQ;
	    break;
	  case OR:
	    code_area[pc].op = iOR;
	    break;
	  case AND:
	    code_area[pc].op = iAND;
	    break;
	  case NOT:
	    code_area[pc].op = iNOT;
	    break;
	  case ivXADDR:
	    code_area[pc].op = ivXADDR;
	    break;
	  case fvXADDR:
	    code_area[pc].op = fvXADDR;
	    break;
	  case ivYADDR:
	    code_area[pc].op = ivYADDR;
	    break;
	  case fvYADDR:
	    code_area[pc].op = fvYADDR;
	    break;
	  case ivZADDR:
	    code_area[pc].op = ivZADDR;
	    break;
	  case fvZADDR:
	    code_area[pc].op = fvZADDR;
	    break;
	  case ipXADDR:
	    code_area[pc].op = ipXADDR;
	    break;
	  case fpXADDR:
	    code_area[pc].op = fpXADDR;
	    break;
	  case ipYADDR:
	    code_area[pc].op = ipYADDR;
	    break;
	  case fpYADDR:
	    code_area[pc].op = fpYADDR;
	    break;
	  case ipZADDR:
	    code_area[pc].op = ipZADDR;
	    break;
	  case fpZADDR:
	    code_area[pc].op = fpZADDR;
	    break;

	  case GATH: 	    // ؿƤӽФ
	  case LOAD:
	  case SAVE:
	  case RAND:
	  case WIDTH:
	  case HEIGH:
	  case DEPTH:
	  case MODULE:
	    code_area[pc].op = op;
	    break;
	}
    } else {		// floating򰷤 *************************
	switch(op) {
	  case iPOP:
	    code_area[pc].op = fiPOP;
	    break;
	  case fPOP:
	    code_area[pc].op = ffPOP;
	    break;
	  case i1POP:
	    code_area[pc].op = fi1POP;
	    break;
	  case f1POP:
	    code_area[pc].op = ff1POP;
	    break;
	  case INT:
	    code_area[pc].op = fINT;
	    break;
	  case FLT:
	    code_area[pc].op = fFLT;
	    break;
	  case INC:
	    code_area[pc].op = fINC;
	    break;
	  case DEC:
	    code_area[pc].op = fDEC;
	    break;
	  case MIN:
	    code_area[pc].op = fMIN;
	    break;
	  case MUL:
	    code_area[pc].op = fMUL;
	    break;
	  case DIV:
	    code_area[pc].op = fDIV;
	    break;
	  case MOD:
	    code_area[pc].op = fMOD;
	    break;
	  case ADD:
	    code_area[pc].op = fADD;
	    break;
	  case SUB:
	    code_area[pc].op = fSUB;
	    break;
	  case GTR:
	    code_area[pc].op = fGTR;
	    break;
	  case GEQ:
	    code_area[pc].op = fGEQ;
	    break;
	  case EQL:
	    code_area[pc].op = fEQL;
	    break;
	  case NEQ:
	    code_area[pc].op = fNEQ;
	    break;
	  case OR:
	    code_area[pc].op = fOR;
	    break;
	  case AND:
	    code_area[pc].op = fAND;
	    break;
	  case NOT:
	    code_area[pc].op = fNOT;
	    break;
	  case ivXADDR:
	    code_area[pc].op = ivXADDR;
	    break;
	  case fvXADDR:
	    code_area[pc].op = fvXADDR;
	    break;
	  case ivYADDR:
	    code_area[pc].op = ivYADDR;
	    break;
	  case fvYADDR:
	    code_area[pc].op = fvYADDR;
	    break;
	  case ivZADDR:
	    code_area[pc].op = ivZADDR;
	    break;
	  case fvZADDR:
	    code_area[pc].op = fvZADDR;
	    break;
	  case ipXADDR:
	    code_area[pc].op = ipXADDR;
	    break;
	  case fpXADDR:
	    code_area[pc].op = fpXADDR;
	    break;
	  case ipYADDR:
	    code_area[pc].op = ipYADDR;
	    break;
	  case fpYADDR:
	    code_area[pc].op = fpYADDR;
	    break;
	  case ipZADDR:
	    code_area[pc].op = ipZADDR;
	    break;
	  case fpZADDR:
	    code_area[pc].op = fpZADDR;
	    break;

	  case GATH: 	    // ؿƤӽФ
	  case LOAD:
	  case SAVE:
	  case RAND:
	  case WIDTH:
	  case HEIGH:
	  case DEPTH:
	  case MODULE:
	    code_area[pc].op = op;
	    break;
	}
    }


#ifdef _VS_INTER_PRINT

    if(!tflag) { // integer Ф ****************************
	switch(op) {
	  case iPOP:
	    fprintf(stderr,"iiPOP\n");
	    break;
	  case fPOP:
	    fprintf(stderr,"ifPOP\n");
	    break;
	  case i1POP:
	    fprintf(stderr,"ii1POP\n");
	    break;
	  case f1POP:
	    fprintf(stderr,"if1POP\n");
	    break;
	  case INT:
	    fprintf(stderr,"iINT\n");
	    break;
	  case FLT:
	    fprintf(stderr,"iFLT\n");
	    break;
	  case INC:
	    fprintf(stderr,"iINC\n");
	    break;
	  case DEC:
	    fprintf(stderr,"iDEC\n");
	    break;
	  case MIN:
	    fprintf(stderr,"iMIN\n");
	    break;
	  case MUL:
	    fprintf(stderr,"iMUL\n");
	    break;
	  case DIV:
	    fprintf(stderr,"iDIV\n");
	    break;
	  case MOD:
	    fprintf(stderr,"iMOD\n");
	    break;
	  case ADD:
	    fprintf(stderr,"iADD\n");
	    break;
	  case SUB:
	    fprintf(stderr,"iSUB\n");
	    break;
	  case GTR:
	    fprintf(stderr,"iGTR\n");
	    break;
	  case GEQ:
	    fprintf(stderr,"iGEQ\n");
	    break;
	  case EQL:
	    fprintf(stderr,"iEQL\n");
	    break;
	  case NEQ:
	    fprintf(stderr,"iNEQ\n");
	    break;
	  case OR:
	    fprintf(stderr,"iOR\n");
	    break;
	  case AND:
	    fprintf(stderr,"iAND\n");
	    break;
	  case NOT:
	    fprintf(stderr,"iNOT\n");
	    break;
	  case ivXADDR:
	    fprintf(stderr,"ivXADDR\n");
	    break;
	  case fvXADDR:
	    fprintf(stderr,"fvXADDR\n");
	    break;
	  case ivYADDR:
	    fprintf(stderr,"ivYADDR\n");
	    break;
	  case fvYADDR:
	    fprintf(stderr,"fvYADDR\n");
	    break;
	  case ivZADDR:
	    fprintf(stderr,"ivZADDR\n");
	    break;
	  case fvZADDR:
	    fprintf(stderr,"fvZADDR\n");
	    break;
	  case ipXADDR:
	    fprintf(stderr,"ipXADDR\n");
	    break;
	  case fpXADDR:
	    fprintf(stderr,"fpXADDR\n");
	  case ipYADDR:
	    fprintf(stderr,"ipYADDR\n");
	    break;
	  case fpYADDR:
	    fprintf(stderr,"fpYADDR\n");
	    break;
	  case ipZADDR:
	    fprintf(stderr,"ipZADDR\n");
	    break;
	  case fpZADDR:
	    fprintf(stderr,"fpZADDR\n");
	    break;
	}
    } else {	// float򰷤 ************************************
	switch(op) {
	  case iPOP:
	    fprintf(stderr,"fiPOP\n");
	    break;
	  case fPOP:
	    fprintf(stderr,"ffPOP\n");
	    break;
	  case i1POP:
	    fprintf(stderr,"fi1POP\n");
	    break;
	  case f1POP:
	    fprintf(stderr,"ff1POP\n");
	    break;
	  case INT:
	    fprintf(stderr,"fINT\n");
	    break;
	  case FLT:
	    fprintf(stderr,"fFLT\n");
	    break;
	  case INC:
	    fprintf(stderr,"fINC\n");
	    break;
	  case DEC:
	    fprintf(stderr,"fDEC\n");
	    break;
	  case MIN:
	    fprintf(stderr,"fMIN\n");
	    break;
	  case MUL:
	    fprintf(stderr,"fMUL\n");
	    break;
	  case DIV:
	    fprintf(stderr,"fDIV\n");
	    break;
	  case MOD:
	    fprintf(stderr,"fMOD\n");
	    break;
	  case ADD:
	    fprintf(stderr,"fADD\n");
	    break;
	  case SUB:
	    fprintf(stderr,"fSUB\n");
	    break;
	  case GTR:
	    fprintf(stderr,"fGTR\n");
	    break;
	  case GEQ:
	    fprintf(stderr,"fGEQ\n");
	    break;
	  case EQL:
	    fprintf(stderr,"fEQL\n");
	    break;
	  case NEQ:
	    fprintf(stderr,"fNEQ\n");
	    break;
	  case OR:
	    fprintf(stderr,"fOR\n");
	    break;
	  case AND:
	    fprintf(stderr,"fAND\n");
	    break;
	  case NOT:
	    fprintf(stderr,"fNOT\n");
	    tflag = 0;
	    break;
	  case ivXADDR:
	    fprintf(stderr,"ivXADDR\n");
	    break;
	  case fvXADDR:
	    fprintf(stderr,"fvXADDR\n");
	    break;
	  case ivYADDR:
	    fprintf(stderr,"ivYADDR\n");
	    break;
	  case fvYADDR:
	    fprintf(stderr,"fvYADDR\n");
	    break;
	  case ivZADDR:
	    fprintf(stderr,"ivZADDR\n");
	    break;
	  case fvZADDR:
	    fprintf(stderr,"fvZADDR\n");
	    break;
	  case ipXADDR:
	    fprintf(stderr,"ipXADDR\n");
	    break;
	  case fpXADDR:
	    fprintf(stderr,"fpXADDR\n");
	  case ipYADDR:
	    fprintf(stderr,"ipYADDR\n");
	    break;
	  case fpYADDR:
	    fprintf(stderr,"fpYADDR\n");
	    break;
	  case ipZADDR:
	    fprintf(stderr,"ipZADDR\n");
	    break;
	  case fpZADDR:
	    fprintf(stderr,"fpZADDR\n");
	    break;
	}
    }

    switch(op) {
      case GATH:
	fprintf(stderr,"GATH\n");
	break;
      case LOAD:
	fprintf(stderr,"LOAD\n");
	break;
      case SAVE:
	fprintf(stderr,"SAVE\n");
	break;
      case RAND:
	fprintf(stderr,"RAND\n");
	break;
      case WIDTH:
	fprintf(stderr,"WIDTH\n");
	break;
      case HEIGH:
	fprintf(stderr,"HEIGH\n");
	break;
      case DEPTH:
	fprintf(stderr,"DEPTH\n");
	break;
      case MODULE:
	fprintf(stderr,"MODULE\n");
	break;
    }

#endif
}

// ѿ -----------
void
Interpreter::e_REG0()
{
    g_table.regist((int)code_area[pc].sb.ag.dt, code_area[pc].sb.vl.sval);
    ++pc;
}
void
Interpreter::e_REG1()
{
    int w = stack_area[--sp].vl.ival;
    g_table.regist((int)code_area[pc].sb.ag.dt, code_area[pc].sb.vl.sval, \
		   w);
    ++pc;
}
void
Interpreter::e_REG2()
{
    int w, h;
    h = stack_area[--sp].vl.ival;
    w = stack_area[--sp].vl.ival;
    g_table.regist((int)code_area[pc].sb.ag.dt, code_area[pc].sb.vl.sval, \
		   w, h);
    ++pc;
}
void
Interpreter::e_REG3()
{
    int w, h, d;
    d = stack_area[--sp].vl.ival;
    h = stack_area[--sp].vl.ival;
    w = stack_area[--sp].vl.ival;
    g_table.regist((int)code_area[pc].sb.ag.dt, code_area[pc].sb.vl.sval, \
		   w, h, d);
    ++pc;
}
