/*********************************************************************
  interpreter.h
    VPE-i (main󥿡ץ꥿)¼¹
*********************************************************************/
#ifndef __VS_INTERPRETER_H
#define __VS_INTERPRETER_H

#include "om_struct.h"
#include "lang.h"

class Interpreter
{
    char	int_form[8];	// putؿѤեޥå
    char	flt_form[8];

    int		sp;
    vs_stack	stack_area[MAX_STACK];
    int		label_area[MAX_LABEL];

    void	(Interpreter::*StepCode[MAX_OP])();

    void	e_JMP();
    void	e_JPF();
    void	e_LBL();

    void	e_GATH();
    void	e_LOAD();
    void	e_SAVE();
    void	e_iPUT();
    void	e_fPUT();
    void	e_sPUT();
    void	e_RAND();
    void	e_SET();
    void	e_WIDTH();
    void	e_HEIGH();
    void	e_DEPTH();
    void	e_MODULE();

    void	e_CLS();
    void	e_REM();

    void	e_REG0();
    void	e_REG1();
    void	e_REG2();
    void	e_REG3();

    void	e_iiPOP();
    void	e_ifPOP();
    void	e_fiPOP();
    void	e_ffPOP();
    void	e_ii1POP();
    void	e_if1POP();
    void	e_fi1POP();
    void	e_ff1POP();

    void	e_iPUSH();
    void	e_fPUSH();
    void	e_sPUSH();

    void	e_iv1PUSH();
    void	e_fv1PUSH();
    void	e_ivPUSH();
    void	e_fvPUSH();
    void	e_svPUSH();

    void	e_ip1PUSH();
    void	e_fp1PUSH();
    void	e_ipPUSH();
    void	e_fpPUSH();
    void	e_spPUSH();

    void	e_ivXADDR();
    void	e_fvXADDR();
    void	e_ivYADDR();
    void	e_fvYADDR();
    void	e_ivZADDR();
    void	e_fvZADDR();

    void	e_ipXADDR();
    void	e_fpXADDR();
    void	e_ipYADDR();
    void	e_fpYADDR();
    void	e_ipZADDR();
    void	e_fpZADDR();

    void	e_iINT();
    void	e_iFLT();
    void	e_iINC();
    void	e_iDEC();
    void	e_iMIN();
    void	e_iMUL();
    void	e_iDIV();
    void	e_iMOD();
    void	e_iADD();
    void	e_iSUB();
    void	e_iGTR();
    void	e_iGEQ();
    void	e_iEQL();
    void	e_iNEQ();
    void	e_iOR();
    void	e_iAND();
    void	e_iNOT();

    void	e_fINT();
    void	e_fFLT();
    void	e_fINC();
    void	e_fDEC();
    void	e_fMIN();
    void	e_fMUL();
    void	e_fDIV();
    void	e_fMOD();
    void	e_fADD();
    void	e_fSUB();
    void	e_fGTR();
    void	e_fGEQ();
    void	e_fEQL();
    void	e_fNEQ();
    void	e_fOR();
    void	e_fAND();
    void	e_fNOT();

  public:
    Interpreter();
   ~Interpreter(){};

    void	execute();
};

extern Interpreter interpreter;

#endif
