/*********************************************************************
  om_recv.cc
    IP => OM ̿
*********************************************************************/
#include "vios_run.h"
#include "om_table.h"


static fd_set	fds;
static int	waitfd;
static int	next;

void
Om::InitFD()
{
    FD_ZERO(&fds);
    waitfd = 0;
    for(int i=0; i<exec_info.host_num; i++) {
	FD_SET(ip_fd[i], &fds);
	if(ip_fd[i] > waitfd) waitfd = ip_fd[i];
    }
    waitfd++;
}

void
Om::FromIP()
{
    next = 1;
    while(next > 0) {
	Select(waitfd, &fds, NULL, NULL, NULL);

	for(int i=0; i<exec_info.host_num; i++) {
	    int recv_id;
	    if(FD_ISSET(ip_fd[i], &fds)) {
		id = i;
		Readn(ip_fd[i], (void*)&recv_id, sizeof(int));
//		fprintf(stderr,"come request:%d from %d.\n", recv_id,i);
		(this->*Om::Recv[recv_id])();
	    }
	    FD_SET(ip_fd[i], &fds);
	    recv_id = -1;
	}
    }
    if(next == -1) {
	for(int i=0; i< exec_info.host_num; i++) 
	    Close(ip_fd[i]);
    }
}

void
Om::RecvDone()
{
    // Ʊ¹Ԥ⥸塼θ뤳
    if(++ip_cnt == exec_info.host_num) {
	ip_cnt = 0; next    =  0;
    }
}

void
Om::RecvEnd()
{
    if(++ip_cnt == exec_info.host_num) {
	ip_cnt = 0; next = -1;
    }
}

// Ūʤ
void
Om::RecvSync()
{
    if(++ip_cnt == exec_info.host_num) {
	for(int i=0; i<exec_info.host_num; i++) {
	    id = i;
	    SendIP(pSync);
	}
	ip_cnt = 0;
    }
}


void
Om::RecvImg()
{
    // ǡꥯȤ  ----------------------------

    int		img_id;
    DivInfo 	div_info[MAX_DIM];
    Readn(ip_fd[id], (void*)&img_id,   sizeof(int));
    Readn(ip_fd[id], (void*)&div_info, sizeof(DivInfo) * 2);

    vs_data*	img = g_table.get(img_id);

    // ǡ  ------------------------------------
    SendIP(pReqImg);
    Writen(ip_fd[id], (void*)&img_id,  sizeof(int));

    if(img->type == iIMG) {
	int* iimg = (int*)img->val + div_info[1].index * img->dim->width;

	for(int i=0; i<div_info[1].width; i++) {
	    Writen(ip_fd[id], (void*)(iimg + div_info[0].index), \
				      sizeof(int)   * div_info[0].width);
	    iimg += img->dim->width;
	}
    } else {
	FLOAT* fimg = (FLOAT*)img->val + div_info[1].index * img->dim->width;

	for(int i=0; i<div_info[1].width; i++) {
	    Writen(ip_fd[id], (void*)(fimg + div_info[0].index), \
				      sizeof(FLOAT) * div_info[0].width);
	    fimg += img->dim->width;
	}
    }
}

void
Om::RecvCub()
{
    // ǡꥯȤ  ----------------------------
    int		cub_id;
    DivInfo 	div_info[MAX_DIM];
    Readn(ip_fd[id], (void*)&cub_id,   sizeof(int));
    Readn(ip_fd[id], (void*)&div_info, sizeof(DivInfo) * MAX_DIM);

    vs_data* cub = g_table.get(cub_id);


    // ǡ  ------------------------------------

    SendIP(pReqCub);
    Writen(ip_fd[id], (void*)&cub_id,  sizeof(int));

    if(cub->type == iCUB) {
	int* icub = (int*)cub->val \
	           + div_info[2].index * cub->dim->width * cub->dim->heigh \
		   + div_info[1].index * cub->dim->width \
		   + div_info[0].index;

	for(int i=0; i<div_info[2].width; i++) {
	    for(int j=0; j<div_info[1].width; j++) {
		Writen(ip_fd[id], icub, sizeof(int) * div_info[0].width);
		icub += cub->dim->width;
	    }
	    icub += cub->dim->width * (cub->dim->heigh - div_info[1].width);
	}
    } else {
	FLOAT* fcub = (FLOAT*)cub->val \
	             + div_info[2].index * cub->dim->width * cub->dim->heigh \
		     + div_info[1].index * cub->dim->width \
		     + div_info[0].index;

	for(int i=0; i<div_info[2].width; i++) {
	    for(int j=0; j<div_info[1].width; j++) {
		Writen(ip_fd[id], fcub, sizeof(FLOAT) * div_info[0].width);
		fcub += cub->dim->width;
	    }
	    fcub += cub->dim->width * (cub->dim->heigh - div_info[1].width);
	}
    }
}

void
Om::RecvValue()
{
    // ǡꥯȤ  ----------------------------
    int		val_id;
    DivInfo 	div_info;
    Readn(ip_fd[id], (void*)&val_id,   sizeof(int));
    Readn(ip_fd[id], (void*)&div_info, sizeof(DivInfo));

    vs_data*	val = g_table.get(val_id);

    // ǡ  ------------------------------------
    SendIP(pReqValue);
    Writen(ip_fd[id], (void*)&val_id,  sizeof(int));

    if(val->type == INT) {
	Writen(ip_fd[id], (void*)(  (int*)val->val + div_info.index), \
	                                sizeof(int) * div_info.width);
    } else {
	Writen(ip_fd[id], (void*)((FLOAT*)val->val + div_info.index), \
	                              sizeof(FLOAT) * div_info.width);
    }
}


// ΰؤΥʤΤ¾ɬ̵Ϥ -------------
void
Om::RecvGather()
{
    vs_data* ptr = module_tab.ptr;

    DivInfo  div_info[3];
    int	     cache[6];
    int	     line;

    int*     iptr;
    FLOAT*   fptr;

#define _VS_GATHER_1D(_VS_TYPE, _VS_TYPE_VAL)				     \
	Readn(ip_fd[id], (void*)div_info, sizeof(DivInfo));		     \
        Readn(ip_fd[id], (void*)cache,    sizeof(int) * 2);		     \
	_VS_TYPE_VAL = (_VS_TYPE*)ptr->val + div_info[0].index + cache[2];   \
	Readn(ip_fd[id], _VS_TYPE_VAL,					     \
	      (div_info[0].width - cache[2] - cache[3]) * sizeof(_VS_TYPE))


#define _VS_GATHER_2D(_VS_TYPE, _VS_TYPE_VAL)				     \
	Readn(ip_fd[id], (void*)div_info, sizeof(DivInfo) * 2);		     \
        Readn(ip_fd[id], (void*)cache,    sizeof(int)     * 4);		     \
	Readn(ip_fd[id], (void*)&line,    sizeof(int));			     \
	_VS_TYPE_VAL = (_VS_TYPE*)ptr->val + (div_info[1].index + cache[0])  \
	                 * ptr->dim->width + (div_info[0].index + cache[2]); \
									     \
	for(int i= 0; i< line; i++) {					     \
	    Readn(ip_fd[id], _VS_TYPE_VAL,				     \
	      (div_info[0].width - cache[2] - cache[3]) * sizeof(_VS_TYPE)); \
	    _VS_TYPE_VAL += ptr->dim->width;				     \
	}

    switch(ptr->type) {
      case INT:
	_VS_GATHER_1D(int,   iptr);
	break;
      case FLT:
	_VS_GATHER_1D(FLOAT, fptr);
	break;
      case iIMG:
	_VS_GATHER_2D(int,   iptr);
	break;
      case fIMG:
	_VS_GATHER_2D(FLOAT, fptr);
	break;
    }

#undef _VS_GATHER_1D
#undef _VS_GAGHER_2D

    if(++ip_cnt == exec_info.host_num) {
	ip_cnt = 0; next = 0;
    }
}

void
Om::RecvUnion()
{
    UnionInfo uni;
    Readn(ip_fd[id], &uni.id, sizeof(UnionInfo) - sizeof(int));

    vs_data* ptr = module_tab.argv[uni.id];

    if(ptr->type != vsAGGRIGATE) {

	// ե  -------------------------------------
	void* temp;
	if(ptr->type & INT) {
	    temp = new int[ptr->size];
	    Readn(ip_fd[id], temp, ptr->size * sizeof(int));
	} else {
	    temp = new FLOAT[ptr->size];
	    Readn(ip_fd[id], temp, ptr->size * sizeof(FLOAT));
	}

	// Unionե  ------------------------------------
	if(ptr->type & INT) {
	    switch(uni.type) {
	      case vsUNI:
		memcpy(ptr->val, temp, sizeof(int) * ptr->size);
		break;
	      case vsADD:
		for(int i=0; i< ptr->size; i++)
		    ((int*)ptr->val)[i] += ((int*)temp)[i];
		break;
	      case vsMAX:
		for(int i=0; i< ptr->size; i++)
		    if(((int*)ptr->val)[i] < ((int*)temp)[i])
			((int*)ptr->val)[i] = ((int*)temp)[i];
		break;
	      case vsMIN:
		for(int i=0; i< ptr->size; i++)
		    if(((int*)ptr->val)[i] > ((int*)temp)[i])
			((int*)ptr->val)[i] = ((int*)temp)[i];
		break;
	      case vsMAX_DEPEND_ON_FIRST:
		if(((int*)ptr->val)[0] < ((int*)temp)[0])
		    memcpy(ptr->val, temp, sizeof(int) * ptr->size);
		break;
	      case vsMIN_DEPEND_ON_FIRST:
		if(((int*)ptr->val)[0] > ((int*)temp)[0])
		    memcpy(ptr->val, temp, sizeof(int) * ptr->size);
		break;
	    }
	    delete[] (int*)temp;
	} else {
	    switch(uni.type) {
	      case vsUNI:
		memcpy(ptr->val, temp, sizeof(FLOAT) * ptr->size);
		break;
	      case vsADD:
		for(int i=0; i< ptr->size; i++)
		    ((FLOAT*)ptr->val)[i] += ((FLOAT*)temp)[i];
		break;
	      case vsMAX:
		for(int i=0; i< ptr->size; i++)
		    if(((FLOAT*)ptr->val)[i] < ((FLOAT*)temp)[i])
			((FLOAT*)ptr->val)[i] = ((FLOAT*)temp)[i];
		break;
	      case vsMIN:
		for(int i=0; i< ptr->size; i++)
		    if(((FLOAT*)ptr->val)[i] > ((FLOAT*)temp)[i])
			((FLOAT*)ptr->val)[i] = ((FLOAT*)temp)[i];
		break;
	      case vsMAX_DEPEND_ON_FIRST:
		if(((FLOAT*)ptr->val)[0] < ((FLOAT*)temp)[0])
		    memcpy(ptr->val, temp, sizeof(FLOAT) * ptr->size);
		break;
	      case vsMIN_DEPEND_ON_FIRST:
		if(((FLOAT*)ptr->val)[0] > ((FLOAT*)temp)[0])
		    memcpy(ptr->val, temp, sizeof(FLOAT) * ptr->size);
		break;
	    }
	    delete[] (FLOAT*)temp;
	}
    }

    // ե  ---------------------------------------------
    if(++ip_cnt == exec_info.host_num) {

	if(ptr->type & INT) {
	    for(int i=0; i<exec_info.host_num; i++) {
		id = i;
		SendIP(pUnion);
		Writen(ip_fd[i], ptr->val, ptr->size * sizeof(int));
	    }
	} else {
	    for(int i=0; i<exec_info.host_num; i++) {
		id = i;
		SendIP(pUnion);
		Writen(ip_fd[i], ptr->val, ptr->size * sizeof(FLOAT));
	    }
	}
	ip_cnt = 0;
    }
}

void
Om::RecvVote()
{
    UnionInfo vote;	// Ȥꤢ
    Readn(ip_fd[id], &vote.id, sizeof(UnionInfo) - sizeof(int));

    vs_data* ptr = module_tab.argv[vote.id];

    // ե  -----------------------------------------
    if(ptr->type == INT) {
	Readn(ip_fd[id],   (int*)ptr->val + vote.type, sizeof(int));
    } else {
	Readn(ip_fd[id], (FLOAT*)ptr->val + vote.type, sizeof(FLOAT));
    }
}
