%{
/*********************************************************************
  vpe-i.l
  VPE-i (main󥿡ץ꥿)
*********************************************************************/



#ifdef DEBUG
#define token(t) printf("%-12s is \"%s\" (lval=%d)\n", #t, \
			  yytext, yylval.id)
#else
#define token(t) return (t)
#endif

static int	s_cnt = 0;
static char	pool[MAX_STR];

%}

%x PRAGMA DQ_STR C_COMM CPP_COMM

ALP			[a-zA-Z_]
DIG			[0-9]
FL1			{DIG}*"."{DIG}+
FL2			{DIG}+"."{DIG}*

%%
"#pragma"		BEGIN PRAGMA;
"("			token (LP);
")"			token (RP);
"{"			token (LC);
"}"			token (RC);
"["			token (LB);
"]"			token (RB);
";"			token (SM);
","			token (CM);
"+"			token (ADDOP);
"-"			token (SUBOP);
"*"			token (MULOP);
"/"			token (DIVOP);
"%"			token (MODOP);
"++"			token (INCOP);
"--"			token (DECOP);
"<"			token (GTROP);
"<="			token (GEQOP);
">"			token (LESOP);
">="			token (LEQOP);
"=="			token (EQOP);
"!="			token (NEOP);
"="			token (ASSIGN);
"&&"			token (ANDOP);
"||"			token (OROP);
"'"			BEGIN  DQ_STR; /* ҤȤޤ */
\"			BEGIN  DQ_STR;
"/*"		        BEGIN  C_COMM; /* " Ĵ */
"//"			BEGIN  CPP_COMM;
[ \t]			;
\n			++line_num;
"else"			token (ELSE);
"for"			token (FOR);
"if"			token (IF);
"while"			token (WHILE);

"int"			yylval.id = INT;    token (TYPE);
"float"			yylval.id = FLT;    token (TYPE);
"iImage"		yylval.id = iIMG;   token (TYPE);
"fImage"		yylval.id = fIMG;   token (TYPE);
"iCube"			yylval.id = iCUB;   token (TYPE);
"fCube"			yylval.id = fCUB;   token (TYPE);

"int*"			yylval.id = INT  + MAX_VAR;   token (TYPE);
"float*"		yylval.id = FLT  + MAX_VAR;   token (TYPE);
"iImage*"		yylval.id = iIMG + MAX_VAR;   token (TYPE);
"fImage*"		yylval.id = fIMG + MAX_VAR;   token (TYPE);
"iCube*"		yylval.id = iCUB + MAX_VAR;   token (TYPE);
"fCube*"		yylval.id = fCUB + MAX_VAR;   token (TYPE);

"gather"		yylval.id = GATH;   token (FUNC);
"imgLoad"		yylval.id = LOAD;   token (FUNC);
"imgSave"		yylval.id = SAVE;   token (FUNC);
"module"		yylval.id = MODULE; token (FUNC);
"height"		yylval.id = HEIGH;  token (FUNC);
"width"			yylval.id = WIDTH;  token (FUNC);
"depth"			yylval.id = DEPTH;  token (FUNC);
"random"		yylval.id = RAND;   token (FUNC);
"redist"		yylval.id = REM;    token (FUNC);
"CACHE"			yylval.id = CACHE;  token (PARAM);
"DIVISION"		yylval.id = DIVIDE; token (PARAM);
"ALL"			yylval.id = dALL;   token (PARAM);
"BLOCK"			yylval.id = dPIXEL; token (PARAM);
"COLUMN"		yylval.id = dCOLOMN;token (PARAM);
"ROW"			yylval.id = dROW;   token (PARAM);
"DEPTH"			yylval.id = dDEPTH; token (PARAM);

"put" 	   		token (PUT_FUNC);
"set"			token (SET_FUNC);


"RAND_MAX" {
    yylval.sb = l_table.regist(RAND_MAX);
    token (INTEGER);
}    
0{DIG}*			|
0(x|X)[a-fA-F0-9]+	|
{DIG}+	{		// 
    yylval.sb = l_table.regist((int)strtol(yytext, NULL, 0));
    token (INTEGER);
}

({FL1}|{FL2}) {		// ư
    yylval.sb = l_table.regist((FLOAT)strtod(yytext, NULL));
    token (FLOTING);
}

{ALP}({ALP}|{DIG})* {	// ʸ
    if((yylval.dt = g_table.get(yytext))!= NULL) {
	switch(yylval.dt->type) {
	  case iIMG :
	    token (iIMG_VAL);
	  case fIMG :
	    token (fIMG_VAL);
	  case iCUB :
	    token (iCUB_VAL);
	  case fCUB :
	    token (fCUB_VAL);
	  case INT:
	    token  (INT_VAL);
	  default:
	    token  (FLT_VAL);
	}
    } else {	
	yylval.sb = l_table.regist(yytext);
	token (NO_DEF);
    }
}

0(x|X)				|
. {
    fprintf(stderr,"unknown work appear at line %d :%c\n",\
	    line_num, yytext[0]);
    return 0;
}


<PRAGMA>"divide_num"		;
<PRAGMA>"host_name"     	;
<PRAGMA>"use_intercomm"		{ if(exec_info.host_num>1) om.each = 1;  }
<PRAGMA>"connect_start"		{ om.ConnectStart(0);                    }
<PRAGMA>"st"   			{ gettimeofday(&om.t_val, NULL);         }
<PRAGMA>"et"   {
    timeval end;
    gettimeofday(&end, NULL);
    
    double t = end.tv_sec  - om.t_val.tv_sec \
	    + (end.tv_usec - om.t_val.tv_usec) * 0.000001;
    fprintf(stderr,"exec time: %1.4lf\n", t);
}
<PRAGMA>[ \t]			;
<PRAGMA>{DIG}+ {		//    = ʬ
    exec_info.div_num = strtol(yytext, NULL, 0);
}
<PRAGMA>{ALP}({ALP}|{DIG})* {	// ʸ = ۥȥ͡
    strcpy(exec_info.ip[exec_info.host_num++].name, yytext);
}
<PRAGMA>\\\n			++line_num;
<PRAGMA>\n			++line_num; BEGIN INITIAL;


<DQ_STR>"'"			|
<DQ_STR>\"	{ 		/* ʸ("ǰϤޤ줿) */

    /* 顼ξϤǽ */
    if(s_cnt >= MAX_STR) {
	fprintf(stderr,"string is too long.\n");
	return 0;
    }
    pool[s_cnt] = '\0';
    yylval.sb = l_table.regist(pool);

    BEGIN INITIAL;
    s_cnt = 0;

    token (STRING);
}
<DQ_STR>\\\"	{
    if(s_cnt < MAX_STR)
	pool[s_cnt++] = '"';
}
<DQ_STR>\\n	{
    ++line_num;
    if(s_cnt < MAX_STR)
        pool[s_cnt++] = '\n';
}
<DQ_STR>.	{
    if(s_cnt < MAX_STR)
        pool[s_cnt++] = yytext[0];
}


<C_COMM>"*/"			BEGIN INITIAL;
<C_COMM>\n			++line_num;
<C_COMM>.			;
<CPP_COMM>\n			++line_num; BEGIN INITIAL;
<CPP_COMM>.			;



<*><<EOF>>			longjmp(END_OF_FILES, 0);
%%
