%{
/**************************************************************
  vpe-i.y
    VPE-i (main󥿡ץ꥿)ʸ
    if-elsecontains 1 shift/reduce conflicts Ȥʤ
***************************************************************/
#include "lang.h"
#include "vios_run.h"
#include "om_table.h"
#include "om_table_sub.h"
#include "generator.h"

static int	        margc;
static int		vtype;

static leaf* 		branch;
static int   		line_num = 1;


extern int yyerror(const char* s);
extern int yylex();

/* ---------------------------------------------------------- */
%}
%union {
    int		id;
    vs_data*	dt;
    vs_sub_dt*	sb;
    leaf*	lf;
}

%token	<id>	TYPE FUNC PUT_FUNC SET_FUNC PARAM
%token	<dt>	iCUB_VAL fCUB_VAL iIMG_VAL fIMG_VAL INT_VAL FLT_VAL
%token	<sb>	INTEGER FLOTING STRING NO_DEF
%token		IF ELSE FOR WHILE EOF

%token		LP RP	/* ( ) */
%token		LC RC	/* { } */
%token		LB RB	/* [ ] */
%token		SM CM	/* ; , */

%right		ASSIGN
%left		ADDOP SUBOP MULOP DIVOP MODOP INCOP DECOP
%left		GTROP GEQOP LESOP LEQOP EQOP NEOP ANDOP OROP
%right		TOPOP

%type	<lf>	statement_list argment_list argment
%type	<lf>	put_argment set_argment set_argment_sub
%type  	<lf>	mass_expr one_expr cond_expr function

%type	<lf>	address_variable	value_variable
%type	<lf>	addr_one_int_variable addr_one_flt_variable
%type	<lf>	    addr_int_variable     addr_flt_variable
%type	<lf>	     one_int_variable      one_flt_variable
%type	<lf>	         int_variable          flt_variable
%type	<lf>	constant

%type  	<id>	if.prefix for.prefix while.prefix

%%
/* -------------------------------------------------------------- */


program	: main_statement_list
        ;

main_statement_list
	: statement	 		{ YYACCEPT; }
        | main_statement_list statement { YYACCEPT; }
	;

statement
	: declaration       SM
        | selection
	| iteration
	| put_function      SM
        | set_function	    SM
        | mass_expr         SM  { generator.genelist($1);     }
	| LC statement_list RC
	;

statement_list
        : statement { /* ߡ */ }
        | statement_list statement
        ;





/*******  ʸmainʸ쥯ȤΤߡ  ********/
declaration
	: TYPE    {    vtype = $1;	                       }
          declarator_list
	;
declarator_list
	: declarator
	| declarator_list CM declarator
	;
declarator
        : NO_DEF
      	          {    generator.generate(REG0, vtype, $1);    }
        | NO_DEF LB one_expr RB
                  {    generator.genelist($3);
		       generator.generate(REG1, vtype, $1);    }
        | NO_DEF LP one_expr CM one_expr RP
                  {    generator.genelist($3);
		       generator.genelist($5);
		       generator.generate(REG2, vtype, $1);    }
        | NO_DEF LP one_expr CM one_expr CM one_expr RP
                  {    generator.genelist($3);
		       generator.genelist($5);
		       generator.genelist($7);
		       generator.generate(REG3, vtype, $1);    }
	;




/* ----- ʲϤǲڤ饳ɤ빽ʸ ----- */

selection 
        : if.prefix statement 
                  {     generator.generate(LBL, $1);       }
	| if.prefix statement ELSE
                  {     generator.generate(JMP, $<id>$ = generator.GetLabel());
		        generator.generate(LBL, $1);
		  }
          statement
                  {     generator.generate(LBL, $<id>4);   }
	;
if.prefix
        : IF LP cond_expr RP
                  {     generator.genelist($3);
			generator.generate(NOT);
		        generator.generate(JPF, $$     = generator.GetLabel());
		  }
	;



iteration
	: for.prefix  statement
                  {     generator.generate(JMP, $1+2);
      		        generator.generate(LBL, $1+1); 
			/* ϻʤΤϢ֤ꤹ */
		  }
        | while.prefix statement
                  {     generator.generate(LBL, $1);
		  }
	;

for.prefix
        : FOR LP mass_expr SM
                 {      generator.genelist($3);
		        generator.generate(LBL, $<id>$ = generator.GetLabel());
		  }
          cond_expr SM
                 {      generator.genelist($6);
		        generator.generate(JPF, $<id>$ = generator.GetLabel());
			generator.generate(JMP, generator.GetLabel());
			generator.generate(LBL, generator.GetLabel());
	          }
          mass_expr RP
                 {      generator.genelist($9);
			generator.generate(JMP, $<id>5);
			generator.generate(LBL, $<id>8);
			$$ = $<id>8;
		 }
        ;

while.prefix
        : WHILE LP cond_expr RP
	         {	generator.generate(JPF, $$ = generator.GetLabel());
		 }
        ;




/*****  ̤ɬס̾ؿǤ ""ϰȤʤ ****/
put_function
        : PUT_FUNC LP put_argment RP
                 {      generator.genelist($3);
			switch(vtype) {
			  case INTEGER:
			    generator.generate(FNC, iPUT, 1);
			    break;
			  case FLOTING:
			    generator.generate(FNC, fPUT, 1);
			    break;
			  default: /*case STRING: */
			    generator.generate(FNC, sPUT, 1);
			}
		 }
put_argment
        : STRING  {    $$ = generator.make(sPUSH, $1);	vtype = STRING; }
        | one_int_variable {  $$ = $1; vtype = INTEGER; }
        | one_flt_variable {  $$ = $1; vtype = FLOTING; }
        | int_variable     {  $$ = $1; vtype = INTEGER; }
        | flt_variable     {  $$ = $1; vtype = FLOTING; }
        ;


set_function
        : SET_FUNC {  margc = 0; }
          LP set_argment RP
	         {       generator.genelist($4);
			 generator.generate(FNC, SET, margc);
		 }
        ;
set_argment
        : address_variable CM PARAM CM set_argment_sub
                 {   margc += 2;
		     branch = generator.make(iPUSH, l_table.regist($3));
		     branch = generator.make(NOP,  $1, branch);
		         $$ = generator.make(NOP,  branch, $5);
	         }
        | address_variable CM PARAM CM PARAM
                 {   margc += 3;
		     branch = generator.make(iPUSH, l_table.regist($3));
		     branch = generator.make(NOP,  $1, branch);
		         $$ = generator.make(NOP,  branch, \
			      generator.make(iPUSH, l_table.regist($5)));
	         }
        ;
set_argment_sub
        : one_expr { $$ = $1; ++margc }
        | set_argment_sub CM one_expr
                   { $$ = generator.make(NOP,$1,$3); ++margc; }

/******  ʸڤλդȤʤ빽ʸʾgenelist϶ػߡ  ******/
mass_expr
	: one_expr
                  {    $$ = $1;      			  }
	| mass_expr CM one_expr
                  {    $$ = generator.make(NOP,   $1, $3);}
	| addr_int_variable ASSIGN one_expr
                  {    $$ = generator.make(iPOP,  $1, $3);}
	| addr_flt_variable ASSIGN one_expr
                  {    $$ = generator.make(fPOP,  $1, $3);}
	| addr_one_int_variable ASSIGN one_expr
                  {    $$ = generator.make(i1POP, $1, $3);}
	| addr_one_flt_variable ASSIGN one_expr
                  {    $$ = generator.make(f1POP, $1, $3);}
	;
one_expr
        : value_variable
        | function
	| LP one_expr RP
                  {    $$ = $2;                           }
	| LP TYPE RP one_expr %prec TOPOP
	          {    $$ = generator.make($2, $4);       }
        | INCOP one_expr
                  {    $$ = generator.make(INC, $2);      }
        | DECOP one_expr
                  {    $$ = generator.make(DEC, $2);      }
        | ADDOP one_expr      %prec TOPOP
                  {    $$ = $2;				  }
        | SUBOP one_expr      %prec TOPOP
                  {    $$ = generator.make(MIN, $2);	  }
	| one_expr MULOP one_expr
                  {    $$ = generator.make(MUL, $1, $3);  }
	| one_expr DIVOP one_expr
                  {    $$ = generator.make(DIV, $1, $3);  }
	| one_expr MODOP one_expr
                  {    $$ = generator.make(MOD, $1, $3);  }
	| one_expr ADDOP one_expr
                  {    $$ = generator.make(ADD, $1, $3);  }
	| one_expr SUBOP one_expr
                  {    $$ = generator.make(SUB, $1, $3);  }
        | one_expr INCOP
                  {    $$ = generator.make(INC, $1);      }
        | one_expr DECOP
                  {    $$ = generator.make(DEC, $1);      }
        ;

cond_expr
	: LP cond_expr RP
                  {    $$ = $2;                           }
        | one_expr GTROP one_expr
                  {    $$ = generator.make(GEQ, $1, $3);  }
	| one_expr GEQOP one_expr
                  {    $$ = generator.make(GTR, $1, $3);  }
	| one_expr LESOP one_expr
                  {    $$ = generator.make(GTR, $3, $1);  }
	| one_expr LEQOP one_expr
                  {    $$ = generator.make(GEQ, $3, $1);  }
	| one_expr EQOP  one_expr
                  {    $$ = generator.make(EQL, $1, $3);  }
	| one_expr NEOP  one_expr 
                  {    $$ = generator.make(NEQ, $1, $3);  }
	| one_expr OROP  one_expr
                  {    $$ = generator.make(OR,  $1, $3);  }
	| one_expr ANDOP one_expr 
                  {    $$ = generator.make(AND, $1, $3);  }
	;


/*******  ͤΤΡʴޤѿؤΥݥ󥿡  *******/

address_variable
        : iCUB_VAL {    $$ = generator.make(ipPUSH, $1);  }
        | fCUB_VAL {    $$ = generator.make(fpPUSH, $1);  }
        | iIMG_VAL {    $$ = generator.make(ipPUSH, $1);  }
        | fIMG_VAL {    $$ = generator.make(fpPUSH, $1);  }
        | addr_one_int_variable
        | addr_one_flt_variable
        ;
addr_one_int_variable
        : INT_VAL  {    $$ = generator.make(ip1PUSH, $1); }
        ;
addr_one_flt_variable
        : FLT_VAL  {    $$ = generator.make(fp1PUSH, $1); }
        ;


addr_int_variable
        : iCUB_VAL LP one_expr CM one_expr CM one_expr RP     {
	    branch = generator.make(NOP,     generator.make(ipPUSH, $1), $3);
	    branch = generator.make(NOP,     branch, $5);
	    $$     = generator.make(ipZADDR, branch, $7);
	}
        | iIMG_VAL LP one_expr CM one_expr RP                 {
	    branch = generator.make(NOP,     generator.make(ipPUSH, $1), $3);
	    $$     = generator.make(ipYADDR, branch, $5);
	}
        | INT_VAL  LB one_expr RB				  {
	    $$     = generator.make(ipXADDR, generator.make(ipPUSH, $1), $3);
	}
        ;
addr_flt_variable
        : fCUB_VAL LP one_expr CM one_expr CM one_expr RP     {
	    branch = generator.make(NOP,     generator.make(fpPUSH, $1), $3);
	    branch = generator.make(NOP,     branch, $5);
	    $$     = generator.make(fpZADDR, branch, $7);
	}
        | fIMG_VAL LP one_expr CM one_expr RP                 {
	    branch = generator.make(NOP,     generator.make(fpPUSH, $1), $3);
	    $$     = generator.make(fpYADDR, branch, $5);
	}
        | FLT_VAL  LB one_expr RB				  {
	    $$     = generator.make(fpXADDR, generator.make(fpPUSH, $1), $3);
	}
        ;


value_variable
        : constant
        | one_int_variable
        | one_flt_variable
        | int_variable
        | flt_variable
        ;

constant
	: INTEGER  {    $$ = generator.make(iPUSH, $1);   }
        | FLOTING  {    $$ = generator.make(fPUSH, $1);   }
	| STRING   {    $$ = generator.make(sPUSH, $1);	  }
        ;
one_int_variable
        : INT_VAL  {    $$ = generator.make(iv1PUSH, $1); }
        ;
one_flt_variable
        : FLT_VAL  {    $$ = generator.make(fv1PUSH, $1); }
        ;
int_variable
        : iCUB_VAL LP one_expr CM one_expr CM one_expr RP     {
	    branch = generator.make(NOP,     generator.make(ipPUSH, $1), $3);
	    branch = generator.make(NOP,     branch, $5);
	    $$     = generator.make(ivZADDR, branch, $7);
	}
        | iIMG_VAL LP one_expr CM one_expr RP                 {
	    branch = generator.make(NOP,     generator.make(ipPUSH, $1), $3);
	    $$     = generator.make(ivYADDR, branch, $5);
	}
        | INT_VAL  LB one_expr RB				  {
	    $$     = generator.make(ivXADDR, generator.make(ipPUSH, $1), $3);
	}
        ;
flt_variable
        : fCUB_VAL LP one_expr CM one_expr CM one_expr RP     {
	    branch = generator.make(NOP,     generator.make(fpPUSH, $1), $3);
	    branch = generator.make(NOP,     branch, $5);
	    $$     = generator.make(fvZADDR, branch, $7);
	}
        | fIMG_VAL LP one_expr CM one_expr RP                 {
	    branch = generator.make(NOP,     generator.make(fpPUSH, $1), $3);
	    $$     = generator.make(fvYADDR, branch, $5);
	}
        | FLT_VAL  LB one_expr RB				  {
	    $$     = generator.make(fvXADDR, generator.make(fpPUSH, $1), $3);
	}
        ;




/* ------------------ ؿ ------------------ */
function
        : FUNC   {     margc = 0;                       }
          LP argment_list RP
	         {       branch = generator.make(iPUSH, l_table.regist(margc));
		         $$     = generator.make($1, $4, branch);
		 }
        ;
argment_list
        :        {       $$ = NULL;                      }
        | argment
                 {       $$ = $1;                        }
        | argment_list CM argment
                 {       $$ = generator.make(NOP,$1,$3); }
        ;
argment : address_variable
                 {       $$ = $1;  ++margc;              }
        | constant
                 {       $$ = $1;  ++margc;              }
        | NO_DEF
                 {       $$ = generator.make(svPUSH,$1);
			 ++margc;
		 }
	| PARAM
	         {       $$ = generator.make(iPUSH,l_table.regist($1));
			 ++margc;
		 }
        ;

%%

int
yyerror(const char* s)
{
    fprintf(stderr,"parsing error at line %d :%s\n", line_num, s); 
    return 0;
}

#include "lex.yy.c"
